<#--
/*******************************************************************************
Copyright (c) 2013-2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED AS IS WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 *******************************************************************************/
-->
<#--
// drv_wifi_tasks.c.ftl: Wi-Fi Driver Tasks
-->
<#if !(WIFI_TASKS?has_content)>
<#assign WIFI_TASKS = "TASK_CALL_NO_RTOS">
</#if>
<#if WIFI_TASKS == "CREATE_TASK" && CONFIG_3RDPARTY_RTOS_USED == "FreeRTOS_V8.x.x">
<#if CONFIG_DRV_WIFI_DEVICE == "MRF24WG">
 <#if CONFIG_DRV_WIFI_RTOS_INIT_TASK == "Standalone">
<@RTOS_TASK_CREATE RTOS_NAME=CONFIG_3RDPARTY_RTOS_USED TASK_FUNC_NAME="DRV_WIFI_InitTask" TASK_NAME="Wi-Fi RTOS Initialization Task" TASK_PRI=CONFIG_DRV_WIFI_RTOS_INIT_TASK_PRIORITY TASK_STK_SZ=CONFIG_DRV_WIFI_RTOS_INIT_TASK_SIZE/>
 </#if>
 <#if CONFIG_DRV_WIFI_RTOS_DEFERRED_ISR == "Standalone">
<@RTOS_TASK_CREATE RTOS_NAME=CONFIG_3RDPARTY_RTOS_USED TASK_FUNC_NAME="DRV_WIFI_Deferred_ISR" TASK_NAME="Wi-Fi RTOS Deferred ISR" TASK_PRI=CONFIG_DRV_WIFI_RTOS_DEFERRED_ISR_PRIORITY TASK_STK_SZ=CONFIG_DRV_WIFI_RTOS_DEFERRED_ISR_SIZE/>
 </#if>
 <#if CONFIG_DRV_WIFI_RTOS_MAC_TASK == "Standalone">
<@RTOS_TASK_CREATE RTOS_NAME=CONFIG_3RDPARTY_RTOS_USED TASK_FUNC_NAME="DRV_WIFI_MACTask" TASK_NAME="Wi-Fi RTOS MAC Task" TASK_PRI=CONFIG_DRV_WIFI_RTOS_MAC_TASK_PRIORITY TASK_STK_SZ=CONFIG_DRV_WIFI_RTOS_MAC_TASK_SIZE/>
 </#if>
</#if><#-- CONFIG_DRV_WIFI_DEVICE == "MRF24WG" -->
</#if><#-- WIFI_TASKS && CONFIG_3RDPARTY_RTOS_USED -->
