/*******************************************************************************
  IC Peripheral Library Template Implementation

  File Name:
    ic_TimerSelect_MX.h

  Summary:
    IC PLIB Template Implementation

  Description:
    This header file contains template implementations
    For Feature : TimerSelect
    and its Variant : MX
    For following APIs :
        PLIB_IC_TimerSelect
        PLIB_IC_ExistsTimerSelect

*******************************************************************************/

//DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) 2013-2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*******************************************************************************/

//DOM-IGNORE-END

#ifndef _IC_TIMERSELECT_MX_H
#define _IC_TIMERSELECT_MX_H

//******************************************************************************
/* Routines available for accessing VREGS, MASKS, POS, LEN are 

  VREGs: 
    _IC_TIMER_SELECT_VREG(index)

  MASKs: 
    _IC_TIMER_SELECT_MASK(index)

  POSs: 
    _IC_TIMER_SELECT_POS(index)

  LENs: 
    _IC_TIMER_SELECT_LEN(index)

*/


//******************************************************************************
/* Function :  IC_TimerSelect_MX

  Summary:
    Implements MX variant of PLIB_IC_TimerSelect 

  Description:
    This template implements the MX variant of the PLIB_IC_TimerSelect function.
*/

PLIB_TEMPLATE void IC_TimerSelect_MX( IC_MODULE_ID index , IC_TIMERS tmr )
{
    _SFR_BIT_WRITE(_IC_TIMER_SELECT_VREG(index),
				_IC_TIMER_SELECT_POS(index), tmr);
}


//******************************************************************************
/* Function :  IC_ExistsTimerSelect_MX

  Summary:
    Implements MX variant of PLIB_IC_ExistsTimerSelect

  Description:
    This template implements the MX variant of the PLIB_IC_ExistsTimerSelect function.
*/

#define PLIB_IC_ExistsTimerSelect PLIB_IC_ExistsTimerSelect
PLIB_TEMPLATE bool IC_ExistsTimerSelect_MX( IC_MODULE_ID index )
{
    return true;
}


#endif /*_IC_TIMERSELECT_MX_H*/

/******************************************************************************
 End of File
*/

