/* Created by plibgen $Revision: 1.31 $ */

#ifndef _CAN_P32MZ2048EFH064_H
#define _CAN_P32MZ2048EFH064_H

/* Section 1 - Enumerate instances, define constants, VREGs */

#include <xc.h>
#include <stdbool.h>

#include "peripheral/peripheral_common_32bit.h"

/* Default definition used for all API dispatch functions */
#ifndef PLIB_INLINE_API
    #define PLIB_INLINE_API extern inline
#endif

/* Default definition used for all other functions */
#ifndef PLIB_INLINE
    #define PLIB_INLINE extern inline
#endif

typedef enum {

    CAN_ID_1 = 0,
    CAN_ID_2,
    CAN_NUMBER_OF_MODULES

} CAN_MODULE_ID;

typedef enum {

    CAN_CHANNEL0 = 0x00,
    CAN_CHANNEL1 = 0x01,
    CAN_CHANNEL2 = 0x02,
    CAN_CHANNEL3 = 0x03,
    CAN_CHANNEL4 = 0x04,
    CAN_CHANNEL5 = 0x05,
    CAN_CHANNEL6 = 0x06,
    CAN_CHANNEL7 = 0x07,
    CAN_CHANNEL8 = 0x08,
    CAN_CHANNEL9 = 0x09,
    CAN_CHANNEL10 = 0x0A,
    CAN_CHANNEL11 = 0x0B,
    CAN_CHANNEL12 = 0x0C,
    CAN_CHANNEL13 = 0x0D,
    CAN_CHANNEL14 = 0x0E,
    CAN_CHANNEL15 = 0x0F,
    CAN_CHANNEL16 = 0x10,
    CAN_CHANNEL17 = 0x11,
    CAN_CHANNEL18 = 0x12,
    CAN_CHANNEL19 = 0x13,
    CAN_CHANNEL20 = 0x14,
    CAN_CHANNEL21 = 0x15,
    CAN_CHANNEL22 = 0x16,
    CAN_CHANNEL23 = 0x17,
    CAN_CHANNEL24 = 0x18,
    CAN_CHANNEL25 = 0x19,
    CAN_CHANNEL26 = 0x1A,
    CAN_CHANNEL27 = 0x1B,
    CAN_CHANNEL28 = 0x1C,
    CAN_CHANNEL29 = 0x1D,
    CAN_CHANNEL30 = 0x1E,
    CAN_CHANNEL31 = 0x1F,
    CAN_TOTAL_CHANNELS = 0x20

} CAN_CHANNEL;

typedef enum {

    CAN_NORMAL_MODE = 0x00,
    CAN_DISABLE_MODE = 0x01,
    CAN_LOOPBACK_MODE = 0x02,
    CAN_LISTEN_ONLY_MODE = 0x03,
    CAN_CONFIGURATION_MODE = 0x04,
    CAN_LISTEN_ALL_MESSAGES_MODE = 0x07

} CAN_OPERATION_MODES;

typedef enum {

    CAN_RX_CHANNEL_NOT_EMPTY = 0x01,
    CAN_RX_CHANNEL_HALF_FULL = 0x02,
    CAN_RX_CHANNEL_FULL = 0x04,
    CAN_RX_CHANNEL_OVERFLOW = 0x08,
    CAN_RX_CHANNEL_ANY_EVENT = 0x0F,
    CAN_TX_CHANNEL_EMPTY = 0x100,
    CAN_TX_CHANNEL_HALF_EMPTY = 0x200,
    CAN_TX_CHANNEL_NOT_FULL = 0x400,
    CAN_TX_CHANNEL_ANY_EVENT = 0x700

} CAN_CHANNEL_EVENT;

typedef enum {

    CAN_BAUD_RATE_PRESCALE_1 = 0,
    CAN_BAUD_RATE_PRESCALE_2 = 1,
    CAN_BAUD_RATE_PRESCALE_3 = 2,
    CAN_BAUD_RATE_PRESCALE_4 = 3,
    CAN_BAUD_RATE_PRESCALE_5 = 4,
    CAN_BAUD_RATE_PRESCALE_6 = 5,
    CAN_BAUD_RATE_PRESCALE_7 = 6,
    CAN_BAUD_RATE_PRESCALE_8 = 7,
    CAN_BAUD_RATE_PRESCALE_9 = 8,
    CAN_BAUD_RATE_PRESCALE_10 = 9,
    CAN_BAUD_RATE_PRESCALE_11 = 10,
    CAN_BAUD_RATE_PRESCALE_12 = 11,
    CAN_BAUD_RATE_PRESCALE_13 = 12,
    CAN_BAUD_RATE_PRESCALE_14 = 13,
    CAN_BAUD_RATE_PRESCALE_15 = 14,
    CAN_BAUD_RATE_PRESCALE_16 = 15,
    CAN_BAUD_RATE_PRESCALE_17 = 16,
    CAN_BAUD_RATE_PRESCALE_18 = 17,
    CAN_BAUD_RATE_PRESCALE_19 = 18,
    CAN_BAUD_RATE_PRESCALE_20 = 19,
    CAN_BAUD_RATE_PRESCALE_21 = 20,
    CAN_BAUD_RATE_PRESCALE_22 = 21,
    CAN_BAUD_RATE_PRESCALE_23 = 22,
    CAN_BAUD_RATE_PRESCALE_24 = 23,
    CAN_BAUD_RATE_PRESCALE_25 = 24,
    CAN_BAUD_RATE_PRESCALE_26 = 25,
    CAN_BAUD_RATE_PRESCALE_27 = 26,
    CAN_BAUD_RATE_PRESCALE_28 = 27,
    CAN_BAUD_RATE_PRESCALE_29 = 28,
    CAN_BAUD_RATE_PRESCALE_30 = 29,
    CAN_BAUD_RATE_PRESCALE_31 = 30,
    CAN_BAUD_RATE_PRESCALE_32 = 31,
    CAN_BAUD_RATE_PRESCALE_33 = 32,
    CAN_BAUD_RATE_PRESCALE_34 = 33,
    CAN_BAUD_RATE_PRESCALE_35 = 34,
    CAN_BAUD_RATE_PRESCALE_36 = 35,
    CAN_BAUD_RATE_PRESCALE_37 = 36,
    CAN_BAUD_RATE_PRESCALE_38 = 37,
    CAN_BAUD_RATE_PRESCALE_39 = 38,
    CAN_BAUD_RATE_PRESCALE_40 = 39,
    CAN_BAUD_RATE_PRESCALE_41 = 40,
    CAN_BAUD_RATE_PRESCALE_42 = 41,
    CAN_BAUD_RATE_PRESCALE_43 = 42,
    CAN_BAUD_RATE_PRESCALE_44 = 43,
    CAN_BAUD_RATE_PRESCALE_45 = 44,
    CAN_BAUD_RATE_PRESCALE_46 = 45,
    CAN_BAUD_RATE_PRESCALE_47 = 46,
    CAN_BAUD_RATE_PRESCALE_48 = 47,
    CAN_BAUD_RATE_PRESCALE_49 = 48,
    CAN_BAUD_RATE_PRESCALE_50 = 49,
    CAN_BAUD_RATE_PRESCALE_51 = 50,
    CAN_BAUD_RATE_PRESCALE_52 = 51,
    CAN_BAUD_RATE_PRESCALE_53 = 52,
    CAN_BAUD_RATE_PRESCALE_54 = 53,
    CAN_BAUD_RATE_PRESCALE_55 = 54,
    CAN_BAUD_RATE_PRESCALE_56 = 55,
    CAN_BAUD_RATE_PRESCALE_57 = 56,
    CAN_BAUD_RATE_PRESCALE_58 = 57,
    CAN_BAUD_RATE_PRESCALE_59 = 58,
    CAN_BAUD_RATE_PRESCALE_60 = 59,
    CAN_BAUD_RATE_PRESCALE_61 = 60,
    CAN_BAUD_RATE_PRESCALE_62 = 61,
    CAN_BAUD_RATE_PRESCALE_63 = 62,
    CAN_BAUD_RATE_PRESCALE_64 = 63

} CAN_BAUD_RATE_PRESCALE;

typedef enum {

    CAN_TIME_SEGMENT_LEN_1TQ = 0x00,
    CAN_TIME_SEGMENT_LEN_2TQ = 0x01,
    CAN_TIME_SEGMENT_LEN_3TQ = 0x02,
    CAN_TIME_SEGMENT_LEN_4TQ = 0x03,
    CAN_TIME_SEGMENT_LEN_5TQ = 0x04,
    CAN_TIME_SEGMENT_LEN_6TQ = 0x05,
    CAN_TIME_SEGMENT_LEN_7TQ = 0x06,
    CAN_TIME_SEGMENT_LEN_8TQ = 0x07

} CAN_TIME_SEGMENT_LENGTH;

typedef enum {

    CAN_CHANNEL0_EVENT = 0x00,
    CAN_CHANNEL1_EVENT = 0x01,
    CAN_CHANNEL2_EVENT = 0x02,
    CAN_CHANNEL3_EVENT = 0x03,
    CAN_CHANNEL4_EVENT = 0x04,
    CAN_CHANNEL5_EVENT = 0x05,
    CAN_CHANNEL6_EVENT = 0x06,
    CAN_CHANNEL7_EVENT = 0x07,
    CAN_CHANNEL8_EVENT = 0x08,
    CAN_CHANNEL9_EVENT = 0x09,
    CAN_CHANNEL10_EVENT = 0x0A,
    CAN_CHANNEL11_EVENT = 0x0B,
    CAN_CHANNEL12_EVENT = 0x0C,
    CAN_CHANNEL13_EVENT = 0x0D,
    CAN_CHANNEL14_EVENT = 0x0E,
    CAN_CHANNEL15_EVENT = 0x0F,
    CAN_CHANNEL16_EVENT = 0x10,
    CAN_CHANNEL17_EVENT = 0x11,
    CAN_CHANNEL18_EVENT = 0x12,
    CAN_CHANNEL19_EVENT = 0x13,
    CAN_CHANNEL20_EVENT = 0x14,
    CAN_CHANNEL21_EVENT = 0x15,
    CAN_CHANNEL22_EVENT = 0x16,
    CAN_CHANNEL23_EVENT = 0x17,
    CAN_CHANNEL24_EVENT = 0x18,
    CAN_CHANNEL25_EVENT = 0x19,
    CAN_CHANNEL26_EVENT = 0x1A,
    CAN_CHANNEL27_EVENT = 0x1B,
    CAN_CHANNEL28_EVENT = 0x1C,
    CAN_CHANNEL29_EVENT = 0x1D,
    CAN_CHANNEL30_EVENT = 0x1E,
    CAN_CHANNEL31_EVENT = 0x1F,
    CAN_NO_EVENT = 0x40,
    CAN_ERROR_EVENT = 0x41,
    CAN_WAKEUP_EVENT = 0x42,
    CAN_RX_CHANNEL_OVERFLOW_EVENT = 0x43,
    CAN_ADDRESS_ERROR_EVENT = 0x44,
    CAN_BUS_BANDWIDTH_ERROR = 0x45,
    CAN_TIMESTAMP_TIMER_EVENT = 0x46,
    CAN_MODE_CHANGE_EVENT = 0x47,
    CAN_INVALID_MESSAGE_RECEIVED_EVENT = 0x48

} CAN_EVENT_CODE;

typedef enum {

    CAN_FILTER0 = 0x00,
    CAN_FILTER1 = 0x01,
    CAN_FILTER2 = 0x02,
    CAN_FILTER3 = 0x03,
    CAN_FILTER4 = 0x04,
    CAN_FILTER5 = 0x05,
    CAN_FILTER6 = 0x06,
    CAN_FILTER7 = 0x07,
    CAN_FILTER8 = 0x08,
    CAN_FILTER9 = 0x09,
    CAN_FILTER10 = 0x0A,
    CAN_FILTER11 = 0x0B,
    CAN_FILTER12 = 0x0C,
    CAN_FILTER13 = 0x0D,
    CAN_FILTER14 = 0x0E,
    CAN_FILTER15 = 0x0F,
    CAN_FILTER16 = 0x10,
    CAN_FILTER17 = 0x11,
    CAN_FILTER18 = 0x12,
    CAN_FILTER19 = 0x13,
    CAN_FILTER20 = 0x14,
    CAN_FILTER21 = 0x15,
    CAN_FILTER22 = 0x16,
    CAN_FILTER23 = 0x17,
    CAN_FILTER24 = 0x18,
    CAN_FILTER25 = 0x19,
    CAN_FILTER26 = 0x1A,
    CAN_FILTER27 = 0x1B,
    CAN_FILTER28 = 0x1C,
    CAN_FILTER29 = 0x1D,
    CAN_FILTER30 = 0x1E,
    CAN_FILTER31 = 0x1F,
    CAN_TOTAL_FILTERS = 0x20

} CAN_FILTER;

typedef enum {

    CAN_FILTER_MASK0 = 0x00,
    CAN_FILTER_MASK1 = 0x01,
    CAN_FILTER_MASK2 = 0x02,
    CAN_FILTER_MASK3 = 0x03,
    CAN_NUMBER_OF_FILTER_MASKS = 0x04

} CAN_FILTER_MASK;

typedef enum {

    CAN_TX_RTR_ENABLED = 0x01,
    CAN_TX_RTR_DISABLED = 0x00

} CAN_TX_RTR;

typedef enum {

    CAN_RX_DATA_ONLY = 0x00,
    CAN_RX_FULL_RECEIVE = 0x01

} CAN_RX_DATA_MODE;

typedef enum {

    CAN_FILTER_MASK_IDE_TYPE = 0x00,
    CAN_FILTER_MASK_ANY_TYPE = 0x01

} CAN_FILTER_MASK_TYPE;

typedef enum {

    CAN_LOWEST_PRIORITY = 0x00,
    CAN_LOW_MEDIUM_PRIORITY = 0x01,
    CAN_HIGH_MEDIUM_PRIORITY = 0x02,
    CAN_HIGHEST_PRIORITY = 0x03

} CAN_TXCHANNEL_PRIORITY;

typedef enum {

    CAN_DNET_FILTER_SIZE_18_BIT = 0x12,
    CAN_DNET_FILTER_SIZE_17_BIT = 0x11,
    CAN_DNET_FILTER_SIZE_16_BIT = 0x10,
    CAN_DNET_FILTER_SIZE_15_BIT = 0x0F,
    CAN_DNET_FILTER_SIZE_14_BIT = 0x0E,
    CAN_DNET_FILTER_SIZE_13_BIT = 0x0D,
    CAN_DNET_FILTER_SIZE_12_BIT = 0x0C,
    CAN_DNET_FILTER_SIZE_11_BIT = 0x0B,
    CAN_DNET_FILTER_SIZE_10_BIT = 0x0A,
    CAN_DNET_FILTER_SIZE_9_BIT = 0x09,
    CAN_DNET_FILTER_SIZE_8_BIT = 0x08,
    CAN_DNET_FILTER_SIZE_7_BIT = 0x07,
    CAN_DNET_FILTER_SIZE_6_BIT = 0x06,
    CAN_DNET_FILTER_SIZE_5_BIT = 0x05,
    CAN_DNET_FILTER_SIZE_4_BIT = 0x04,
    CAN_DNET_FILTER_SIZE_3_BIT = 0x03,
    CAN_DNET_FILTER_SIZE_2_BIT = 0x02,
    CAN_DNET_FILTER_SIZE_1_BIT = 0x01,
    CAN_DNET_FILTER_DISABLE = 0x00

} CAN_DNET_FILTER_SIZE;

typedef enum {

    CAN_TX_EVENT = 0x01,
    CAN_RX_EVENT = 0x02,
    CAN_TIMESTAMP_TIMER_OVERFLOW_EVENT = 0x04,
    CAN_OPERATION_MODE_CHANGE_EVENT = 0x08,
    CAN_RX_OVERFLOW_EVENT = 0x800,
    CAN_SYSTEM_ERROR_EVENT = 0x1000,
    CAN_BUS_ERROR_EVENT = 0x2000,
    CAN_BUS_ACTIVITY_WAKEUP_EVENT = 0x4000,
    CAN_INVALID_RX_MESSAGE_EVENT = 0x8000,
    CAN_All_EVENTS = 0xF80F

} CAN_MODULE_EVENT;

typedef enum {

    CAN_TX_RX_WARNING_STATE = 0x10000,
    CAN_RX_WARNING_STATE = 0x20000,
    CAN_TX_WARNING_STATE = 0x40000,
    CAN_RX_BUS_PASSIVE_STATE = 0x80000,
    CAN_TX_BUS_PASSIVE_STATE = 0x100000,
    CAN_TX_BUS_OFF_STATE = 0x200000

} CAN_ERROR_STATE;

typedef enum {

    CAN_EID = 0x00,
    CAN_SID = 0x01

} CAN_ID_TYPE;

typedef enum {

    CAN_CHANNEL0_MASK = 0x00000001,
    CAN_CHANNEL1_MASK = 0x00000002,
    CAN_CHANNEL2_MASK = 0x00000004,
    CAN_CHANNEL3_MASK = 0x00000008,
    CAN_CHANNEL4_MASK = 0x00000010,
    CAN_CHANNEL5_MASK = 0x00000020,
    CAN_CHANNEL6_MASK = 0x00000040,
    CAN_CHANNEL7_MASK = 0x00000080,
    CAN_CHANNEL8_MASK = 0x00000100,
    CAN_CHANNEL9_MASK = 0x00000200,
    CAN_CHANNEL10_MASK = 0x00000400,
    CAN_CHANNEL11_MASK = 0x00000800,
    CAN_CHANNEL12_MASK = 0x00001000,
    CAN_CHANNEL13_MASK = 0x00002000,
    CAN_CHANNEL14_MASK = 0x00004000,
    CAN_CHANNEL15_MASK = 0x00008000,
    CAN_CHANNEL16_MASK = 0x00010000,
    CAN_CHANNEL17_MASK = 0x00020000,
    CAN_CHANNEL18_MASK = 0x00040000,
    CAN_CHANNEL19_MASK = 0x00080000,
    CAN_CHANNEL20_MASK = 0x00100000,
    CAN_CHANNEL21_MASK = 0x00200000,
    CAN_CHANNEL22_MASK = 0x00400000,
    CAN_CHANNEL23_MASK = 0x00800000,
    CAN_CHANNEL24_MASK = 0x01000000,
    CAN_CHANNEL25_MASK = 0x02000000,
    CAN_CHANNEL26_MASK = 0x04000000,
    CAN_CHANNEL27_MASK = 0x08000000,
    CAN_CHANNEL28_MASK = 0x10000000,
    CAN_CHANNEL29_MASK = 0x20000000,
    CAN_CHANNEL30_MASK = 0x40000000,
    CAN_CHANNEL31_MASK = 0x80000000,
    CAN_ANYCHANNEL_MASK = 0xFFFFFFFF

} CAN_CHANNEL_MASK;

typedef enum {

    CAN_TX_CHANNEL_TRANSMITTING = 0x01,
    CAN_TX_CHANNEL_ERROR = 0x02,
    CAN_TX_CHANNEL_ARBITRATION_LOST = 0x04

} CAN_TX_CHANNEL_STATUS;

PLIB_INLINE SFR_TYPE* _CAN_DEVICE_NET_CONFIG_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CON;
        case CAN_ID_2 :
            return &C2CON;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ACTIVE_STATUS_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CON;
        case CAN_ID_2 :
            return &C2CON;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_STOP_IN_IDLE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CON;
        case CAN_ID_2 :
            return &C2CON;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ENABLE_CONTROL_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CON;
        case CAN_ID_2 :
            return &C2CON;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TIMESTAMP_ENABLE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CON;
        case CAN_ID_2 :
            return &C2CON;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_OPERATION_MODE_READ_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CON;
        case CAN_ID_2 :
            return &C2CON;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_OPERATION_MODE_WRITE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CON;
        case CAN_ID_2 :
            return &C2CON;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_PENDING_TRANS_ABORT_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CON;
        case CAN_ID_2 :
            return &C2CON;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_BAUD_RATE_PRESCALE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CFG;
        case CAN_ID_2 :
            return &C2CFG;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_SYNC_JUMP_WIDTH_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CFG;
        case CAN_ID_2 :
            return &C2CFG;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_PROPAGATION_TIME_SEG_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CFG;
        case CAN_ID_2 :
            return &C2CFG;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_PHASE1_SEG_LENGTH_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CFG;
        case CAN_ID_2 :
            return &C2CFG;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_BUS_LINE_3TIMES_SAMPLING_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CFG;
        case CAN_ID_2 :
            return &C2CFG;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_PHASE2_SEG_LENGTH_FREELY_PGM_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CFG;
        case CAN_ID_2 :
            return &C2CFG;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_PHASE2_SEG_LENGTH_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CFG;
        case CAN_ID_2 :
            return &C2CFG;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_BUS_ACTIVITY_WAKEUP_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CFG;
        case CAN_ID_2 :
            return &C2CFG;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_BUS_SPEED_SETUP_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1CFG;
        case CAN_ID_2 :
            return &C2CFG;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_IVRIE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_WAKIE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_CERRIE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_SERRIE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_RBOVIE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_MODIE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_CTMRIE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_RBIE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_TBIE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_IVRIF_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_ENABLE_WAKIF_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_GET_CERRIF_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_GET_SERRIF_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_GET_RBOVIF_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_GET_MODIF_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_GET_CTMRIF_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_GET_RBIF_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MODULE_EVENT_GET_TBIF_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1INT;
        case CAN_ID_2 :
            return &C2INT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_LATEST_FILTER_MATCH_GET_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1VEC;
        case CAN_ID_2 :
            return &C2VEC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_PENDING_EVENTS_GET_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1VEC;
        case CAN_ID_2 :
            return &C2VEC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ERR_STATE_TXBO_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TREC;
        case CAN_ID_2 :
            return &C2TREC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ERR_STATE_TXBP_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TREC;
        case CAN_ID_2 :
            return &C2TREC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ERR_STATE_RXBP_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TREC;
        case CAN_ID_2 :
            return &C2TREC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ERR_STATE_TXWARN_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TREC;
        case CAN_ID_2 :
            return &C2TREC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ERR_STATE_RXWARN_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TREC;
        case CAN_ID_2 :
            return &C2TREC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ERR_STATE_EWARN_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TREC;
        case CAN_ID_2 :
            return &C2TREC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_ERR_COUNT_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TREC;
        case CAN_ID_2 :
            return &C2TREC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RECV_ERR_COUNT_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TREC;
        case CAN_ID_2 :
            return &C2TREC;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ALL_CHANNEL_EVENTS_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FSTAT;
        case CAN_ID_2 :
            return &C2FSTAT;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_ALL_CHANNEL_OVERFLOW_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXOVF;
        case CAN_ID_2 :
            return &C2RXOVF;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TIMESTAMP_SET_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TMR;
        case CAN_ID_2 :
            return &C2TMR;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TIMESTAMP_PRESCALER_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1TMR;
        case CAN_ID_2 :
            return &C2TMR;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK0_SID_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM0;
        case CAN_ID_2 :
            return &C2RXM0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK0_MIDE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM0;
        case CAN_ID_2 :
            return &C2RXM0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK0_EID_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM0;
        case CAN_ID_2 :
            return &C2RXM0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK1_SID_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM1;
        case CAN_ID_2 :
            return &C2RXM1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK1_MIDE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM1;
        case CAN_ID_2 :
            return &C2RXM1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK1_EID_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM1;
        case CAN_ID_2 :
            return &C2RXM1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK2_SID_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM2;
        case CAN_ID_2 :
            return &C2RXM2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK2_MIDE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM2;
        case CAN_ID_2 :
            return &C2RXM2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK2_EID_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM2;
        case CAN_ID_2 :
            return &C2RXM2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK3_SID_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM3;
        case CAN_ID_2 :
            return &C2RXM3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK3_MIDE_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM3;
        case CAN_ID_2 :
            return &C2RXM3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_MASK3_EID_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXM3;
        case CAN_ID_2 :
            return &C2RXM3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON0;
        case CAN_ID_2 :
            return &C2FLTCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON1;
        case CAN_ID_2 :
            return &C2FLTCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON2;
        case CAN_ID_2 :
            return &C2FLTCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON3;
        case CAN_ID_2 :
            return &C2FLTCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON4;
        case CAN_ID_2 :
            return &C2FLTCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON5;
        case CAN_ID_2 :
            return &C2FLTCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON6;
        case CAN_ID_2 :
            return &C2FLTCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_FILTERSEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_TO_CHANNEL_MASKSEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_ENABLE31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FLTCON7;
        case CAN_ID_2 :
            return &C2FLTCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF0;
        case CAN_ID_2 :
            return &C2RXF0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF0;
        case CAN_ID_2 :
            return &C2RXF0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF0;
        case CAN_ID_2 :
            return &C2RXF0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF1;
        case CAN_ID_2 :
            return &C2RXF1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF1;
        case CAN_ID_2 :
            return &C2RXF1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF1;
        case CAN_ID_2 :
            return &C2RXF1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF2;
        case CAN_ID_2 :
            return &C2RXF2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF2;
        case CAN_ID_2 :
            return &C2RXF2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF2;
        case CAN_ID_2 :
            return &C2RXF2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF3;
        case CAN_ID_2 :
            return &C2RXF3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF3;
        case CAN_ID_2 :
            return &C2RXF3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF3;
        case CAN_ID_2 :
            return &C2RXF3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF4;
        case CAN_ID_2 :
            return &C2RXF4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF4;
        case CAN_ID_2 :
            return &C2RXF4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF4;
        case CAN_ID_2 :
            return &C2RXF4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF5;
        case CAN_ID_2 :
            return &C2RXF5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF5;
        case CAN_ID_2 :
            return &C2RXF5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF5;
        case CAN_ID_2 :
            return &C2RXF5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF6;
        case CAN_ID_2 :
            return &C2RXF6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF6;
        case CAN_ID_2 :
            return &C2RXF6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF6;
        case CAN_ID_2 :
            return &C2RXF6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF7;
        case CAN_ID_2 :
            return &C2RXF7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF7;
        case CAN_ID_2 :
            return &C2RXF7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF7;
        case CAN_ID_2 :
            return &C2RXF7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF8;
        case CAN_ID_2 :
            return &C2RXF8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF8;
        case CAN_ID_2 :
            return &C2RXF8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF8;
        case CAN_ID_2 :
            return &C2RXF8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF9;
        case CAN_ID_2 :
            return &C2RXF9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF9;
        case CAN_ID_2 :
            return &C2RXF9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF9;
        case CAN_ID_2 :
            return &C2RXF9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF10;
        case CAN_ID_2 :
            return &C2RXF10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF10;
        case CAN_ID_2 :
            return &C2RXF10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF10;
        case CAN_ID_2 :
            return &C2RXF10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF11;
        case CAN_ID_2 :
            return &C2RXF11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF11;
        case CAN_ID_2 :
            return &C2RXF11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF11;
        case CAN_ID_2 :
            return &C2RXF11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF12;
        case CAN_ID_2 :
            return &C2RXF12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF12;
        case CAN_ID_2 :
            return &C2RXF12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF12;
        case CAN_ID_2 :
            return &C2RXF12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF13;
        case CAN_ID_2 :
            return &C2RXF13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF13;
        case CAN_ID_2 :
            return &C2RXF13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF13;
        case CAN_ID_2 :
            return &C2RXF13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF14;
        case CAN_ID_2 :
            return &C2RXF14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF14;
        case CAN_ID_2 :
            return &C2RXF14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF14;
        case CAN_ID_2 :
            return &C2RXF14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF15;
        case CAN_ID_2 :
            return &C2RXF15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF15;
        case CAN_ID_2 :
            return &C2RXF15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF15;
        case CAN_ID_2 :
            return &C2RXF15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF16;
        case CAN_ID_2 :
            return &C2RXF16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF16;
        case CAN_ID_2 :
            return &C2RXF16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF16;
        case CAN_ID_2 :
            return &C2RXF16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF17;
        case CAN_ID_2 :
            return &C2RXF17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF17;
        case CAN_ID_2 :
            return &C2RXF17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF17;
        case CAN_ID_2 :
            return &C2RXF17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF18;
        case CAN_ID_2 :
            return &C2RXF18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF18;
        case CAN_ID_2 :
            return &C2RXF18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF18;
        case CAN_ID_2 :
            return &C2RXF18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF19;
        case CAN_ID_2 :
            return &C2RXF19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF19;
        case CAN_ID_2 :
            return &C2RXF19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF19;
        case CAN_ID_2 :
            return &C2RXF19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF20;
        case CAN_ID_2 :
            return &C2RXF20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF20;
        case CAN_ID_2 :
            return &C2RXF20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF20;
        case CAN_ID_2 :
            return &C2RXF20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF21;
        case CAN_ID_2 :
            return &C2RXF21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF21;
        case CAN_ID_2 :
            return &C2RXF21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF21;
        case CAN_ID_2 :
            return &C2RXF21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF22;
        case CAN_ID_2 :
            return &C2RXF22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF22;
        case CAN_ID_2 :
            return &C2RXF22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF22;
        case CAN_ID_2 :
            return &C2RXF22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF23;
        case CAN_ID_2 :
            return &C2RXF23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF23;
        case CAN_ID_2 :
            return &C2RXF23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF23;
        case CAN_ID_2 :
            return &C2RXF23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF24;
        case CAN_ID_2 :
            return &C2RXF24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF24;
        case CAN_ID_2 :
            return &C2RXF24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF24;
        case CAN_ID_2 :
            return &C2RXF24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF25;
        case CAN_ID_2 :
            return &C2RXF25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF25;
        case CAN_ID_2 :
            return &C2RXF25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF25;
        case CAN_ID_2 :
            return &C2RXF25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF26;
        case CAN_ID_2 :
            return &C2RXF26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF26;
        case CAN_ID_2 :
            return &C2RXF26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF26;
        case CAN_ID_2 :
            return &C2RXF26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF27;
        case CAN_ID_2 :
            return &C2RXF27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF27;
        case CAN_ID_2 :
            return &C2RXF27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF27;
        case CAN_ID_2 :
            return &C2RXF27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF28;
        case CAN_ID_2 :
            return &C2RXF28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF28;
        case CAN_ID_2 :
            return &C2RXF28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF28;
        case CAN_ID_2 :
            return &C2RXF28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF29;
        case CAN_ID_2 :
            return &C2RXF29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF29;
        case CAN_ID_2 :
            return &C2RXF29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF29;
        case CAN_ID_2 :
            return &C2RXF29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF30;
        case CAN_ID_2 :
            return &C2RXF30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF30;
        case CAN_ID_2 :
            return &C2RXF30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF30;
        case CAN_ID_2 :
            return &C2RXF30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_SID31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF31;
        case CAN_ID_2 :
            return &C2RXF31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EXID31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF31;
        case CAN_ID_2 :
            return &C2RXF31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FILTER_CONFIGURE_EID31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1RXF31;
        case CAN_ID_2 :
            return &C2RXF31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_MEMORY_BUFFER_ASSIGN_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOBA;
        case CAN_ID_2 :
            return &C2FIFOBA;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON0;
        case CAN_ID_2 :
            return &C2FIFOCON0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON1;
        case CAN_ID_2 :
            return &C2FIFOCON1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON2;
        case CAN_ID_2 :
            return &C2FIFOCON2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON3;
        case CAN_ID_2 :
            return &C2FIFOCON3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON4;
        case CAN_ID_2 :
            return &C2FIFOCON4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON5;
        case CAN_ID_2 :
            return &C2FIFOCON5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON6;
        case CAN_ID_2 :
            return &C2FIFOCON6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON7;
        case CAN_ID_2 :
            return &C2FIFOCON7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON8;
        case CAN_ID_2 :
            return &C2FIFOCON8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON9;
        case CAN_ID_2 :
            return &C2FIFOCON9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON10;
        case CAN_ID_2 :
            return &C2FIFOCON10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON11;
        case CAN_ID_2 :
            return &C2FIFOCON11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON12;
        case CAN_ID_2 :
            return &C2FIFOCON12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON13;
        case CAN_ID_2 :
            return &C2FIFOCON13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON14;
        case CAN_ID_2 :
            return &C2FIFOCON14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON15;
        case CAN_ID_2 :
            return &C2FIFOCON15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON16;
        case CAN_ID_2 :
            return &C2FIFOCON16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON17;
        case CAN_ID_2 :
            return &C2FIFOCON17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON18;
        case CAN_ID_2 :
            return &C2FIFOCON18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON19;
        case CAN_ID_2 :
            return &C2FIFOCON19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON20;
        case CAN_ID_2 :
            return &C2FIFOCON20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON21;
        case CAN_ID_2 :
            return &C2FIFOCON21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON22;
        case CAN_ID_2 :
            return &C2FIFOCON22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON23;
        case CAN_ID_2 :
            return &C2FIFOCON23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON24;
        case CAN_ID_2 :
            return &C2FIFOCON24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON25;
        case CAN_ID_2 :
            return &C2FIFOCON25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON26;
        case CAN_ID_2 :
            return &C2FIFOCON26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON27;
        case CAN_ID_2 :
            return &C2FIFOCON27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON28;
        case CAN_ID_2 :
            return &C2FIFOCON28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON29;
        case CAN_ID_2 :
            return &C2FIFOCON29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON30;
        case CAN_ID_2 :
            return &C2FIFOCON30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_PRIORITY_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANSMIT_RTREN_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_FLUSH_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXERR_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_STATUS_TXLARB_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TRANS_ABORT_STATUS_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_DIRECTION_SET_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FOR_RECV_SET_DONLY_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_UPDATE_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_RESET_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_FSIZE_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOCON31;
        case CAN_ID_2 :
            return &C2FIFOCON31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT0;
        case CAN_ID_2 :
            return &C2FIFOINT0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT1;
        case CAN_ID_2 :
            return &C2FIFOINT1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT2;
        case CAN_ID_2 :
            return &C2FIFOINT2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT3;
        case CAN_ID_2 :
            return &C2FIFOINT3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT4;
        case CAN_ID_2 :
            return &C2FIFOINT4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT5;
        case CAN_ID_2 :
            return &C2FIFOINT5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT6;
        case CAN_ID_2 :
            return &C2FIFOINT6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT7;
        case CAN_ID_2 :
            return &C2FIFOINT7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT8;
        case CAN_ID_2 :
            return &C2FIFOINT8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT9;
        case CAN_ID_2 :
            return &C2FIFOINT9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT10;
        case CAN_ID_2 :
            return &C2FIFOINT10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT11;
        case CAN_ID_2 :
            return &C2FIFOINT11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT12;
        case CAN_ID_2 :
            return &C2FIFOINT12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT13;
        case CAN_ID_2 :
            return &C2FIFOINT13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT14;
        case CAN_ID_2 :
            return &C2FIFOINT14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT15;
        case CAN_ID_2 :
            return &C2FIFOINT15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT16;
        case CAN_ID_2 :
            return &C2FIFOINT16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT17;
        case CAN_ID_2 :
            return &C2FIFOINT17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT18;
        case CAN_ID_2 :
            return &C2FIFOINT18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT19;
        case CAN_ID_2 :
            return &C2FIFOINT19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT20;
        case CAN_ID_2 :
            return &C2FIFOINT20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT21;
        case CAN_ID_2 :
            return &C2FIFOINT21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT22;
        case CAN_ID_2 :
            return &C2FIFOINT22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT23;
        case CAN_ID_2 :
            return &C2FIFOINT23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT24;
        case CAN_ID_2 :
            return &C2FIFOINT24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT25;
        case CAN_ID_2 :
            return &C2FIFOINT25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT26;
        case CAN_ID_2 :
            return &C2FIFOINT26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT27;
        case CAN_ID_2 :
            return &C2FIFOINT27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT28;
        case CAN_ID_2 :
            return &C2FIFOINT28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT29;
        case CAN_ID_2 :
            return &C2FIFOINT29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT30;
        case CAN_ID_2 :
            return &C2FIFOINT30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXNFULL_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXHALF_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXOVFL_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXFULL_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXHALF_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXNFULL_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXHALF_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_TXEMPTY_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXOVFL_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXFULL_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXHALF_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOINT31;
        case CAN_ID_2 :
            return &C2FIFOINT31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL0_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA0;
        case CAN_ID_2 :
            return &C2FIFOUA0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL1_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA1;
        case CAN_ID_2 :
            return &C2FIFOUA1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL2_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA2;
        case CAN_ID_2 :
            return &C2FIFOUA2;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL3_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA3;
        case CAN_ID_2 :
            return &C2FIFOUA3;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL4_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA4;
        case CAN_ID_2 :
            return &C2FIFOUA4;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL5_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA5;
        case CAN_ID_2 :
            return &C2FIFOUA5;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL6_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA6;
        case CAN_ID_2 :
            return &C2FIFOUA6;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL7_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA7;
        case CAN_ID_2 :
            return &C2FIFOUA7;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL8_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA8;
        case CAN_ID_2 :
            return &C2FIFOUA8;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL9_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA9;
        case CAN_ID_2 :
            return &C2FIFOUA9;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL10_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA10;
        case CAN_ID_2 :
            return &C2FIFOUA10;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL11_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA11;
        case CAN_ID_2 :
            return &C2FIFOUA11;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL12_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA12;
        case CAN_ID_2 :
            return &C2FIFOUA12;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL13_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA13;
        case CAN_ID_2 :
            return &C2FIFOUA13;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL14_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA14;
        case CAN_ID_2 :
            return &C2FIFOUA14;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL15_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA15;
        case CAN_ID_2 :
            return &C2FIFOUA15;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL16_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA16;
        case CAN_ID_2 :
            return &C2FIFOUA16;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL17_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA17;
        case CAN_ID_2 :
            return &C2FIFOUA17;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL18_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA18;
        case CAN_ID_2 :
            return &C2FIFOUA18;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL19_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA19;
        case CAN_ID_2 :
            return &C2FIFOUA19;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL20_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA20;
        case CAN_ID_2 :
            return &C2FIFOUA20;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL21_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA21;
        case CAN_ID_2 :
            return &C2FIFOUA21;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL22_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA22;
        case CAN_ID_2 :
            return &C2FIFOUA22;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL23_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA23;
        case CAN_ID_2 :
            return &C2FIFOUA23;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL24_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA24;
        case CAN_ID_2 :
            return &C2FIFOUA24;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL25_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA25;
        case CAN_ID_2 :
            return &C2FIFOUA25;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL26_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA26;
        case CAN_ID_2 :
            return &C2FIFOUA26;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL27_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA27;
        case CAN_ID_2 :
            return &C2FIFOUA27;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL28_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA28;
        case CAN_ID_2 :
            return &C2FIFOUA28;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL29_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA29;
        case CAN_ID_2 :
            return &C2FIFOUA29;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL30_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA30;
        case CAN_ID_2 :
            return &C2FIFOUA30;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_TYPE* _CAN_TX_RX_USER_ADDRESS_CHANNEL31_VREG(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return &C1FIFOUA31;
        case CAN_ID_2 :
            return &C2FIFOUA31;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_TYPE*)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DEVICE_NET_CONFIG_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_DNCNT_MASK;
        case CAN_ID_2 :
            return _C2CON_DNCNT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ACTIVE_STATUS_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_CANBUSY_MASK;
        case CAN_ID_2 :
            return _C2CON_CANBUSY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_STOP_IN_IDLE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_SIDL_MASK;
        case CAN_ID_2 :
            return _C2CON_SIDL_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ENABLE_CONTROL_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_ON_MASK;
        case CAN_ID_2 :
            return _C2CON_ON_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TIMESTAMP_ENABLE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_CANCAP_MASK;
        case CAN_ID_2 :
            return _C2CON_CANCAP_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_OPERATION_MODE_READ_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_OPMOD_MASK;
        case CAN_ID_2 :
            return _C2CON_OPMOD_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_OPERATION_MODE_WRITE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_REQOP_MASK;
        case CAN_ID_2 :
            return _C2CON_REQOP_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PENDING_TRANS_ABORT_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_ABAT_MASK;
        case CAN_ID_2 :
            return _C2CON_ABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BAUD_RATE_PRESCALE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_BRP_MASK;
        case CAN_ID_2 :
            return _C2CFG_BRP_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_SYNC_JUMP_WIDTH_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SJW_MASK;
        case CAN_ID_2 :
            return _C2CFG_SJW_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PROPAGATION_TIME_SEG_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_PRSEG_MASK;
        case CAN_ID_2 :
            return _C2CFG_PRSEG_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PHASE1_SEG_LENGTH_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SEG1PH_MASK;
        case CAN_ID_2 :
            return _C2CFG_SEG1PH_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BUS_LINE_3TIMES_SAMPLING_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SAM_MASK;
        case CAN_ID_2 :
            return _C2CFG_SAM_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PHASE2_SEG_LENGTH_FREELY_PGM_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SEG2PHTS_MASK;
        case CAN_ID_2 :
            return _C2CFG_SEG2PHTS_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PHASE2_SEG_LENGTH_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SEG2PH_MASK;
        case CAN_ID_2 :
            return _C2CFG_SEG2PH_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BUS_ACTIVITY_WAKEUP_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_WAKFIL_MASK;
        case CAN_ID_2 :
            return _C2CFG_WAKFIL_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BUS_SPEED_SETUP_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_IVRIE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_IVRIE_MASK;
        case CAN_ID_2 :
            return _C2INT_IVRIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_WAKIE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_WAKIE_MASK;
        case CAN_ID_2 :
            return _C2INT_WAKIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_CERRIE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CERRIE_MASK;
        case CAN_ID_2 :
            return _C2INT_CERRIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_SERRIE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_SERRIE_MASK;
        case CAN_ID_2 :
            return _C2INT_SERRIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_RBOVIE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBOVIE_MASK;
        case CAN_ID_2 :
            return _C2INT_RBOVIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_MODIE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_MODIE_MASK;
        case CAN_ID_2 :
            return _C2INT_MODIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_CTMRIE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CTMRIE_MASK;
        case CAN_ID_2 :
            return _C2INT_CTMRIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_RBIE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBIE_MASK;
        case CAN_ID_2 :
            return _C2INT_RBIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_TBIE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_TBIE_MASK;
        case CAN_ID_2 :
            return _C2INT_TBIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_IVRIF_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_IVRIF_MASK;
        case CAN_ID_2 :
            return _C2INT_IVRIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_WAKIF_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_WAKIF_MASK;
        case CAN_ID_2 :
            return _C2INT_WAKIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_CERRIF_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CERRIF_MASK;
        case CAN_ID_2 :
            return _C2INT_CERRIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_SERRIF_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_SERRIF_MASK;
        case CAN_ID_2 :
            return _C2INT_SERRIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_RBOVIF_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBOVIF_MASK;
        case CAN_ID_2 :
            return _C2INT_RBOVIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_MODIF_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_MODIF_MASK;
        case CAN_ID_2 :
            return _C2INT_MODIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_CTMRIF_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CTMRIF_MASK;
        case CAN_ID_2 :
            return _C2INT_CTMRIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_RBIF_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBIF_MASK;
        case CAN_ID_2 :
            return _C2INT_RBIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_TBIF_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_TBIF_MASK;
        case CAN_ID_2 :
            return _C2INT_TBIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_LATEST_FILTER_MATCH_GET_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1VEC_FILHIT_MASK;
        case CAN_ID_2 :
            return _C2VEC_FILHIT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PENDING_EVENTS_GET_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1VEC_ICODE_MASK;
        case CAN_ID_2 :
            return _C2VEC_ICODE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_TXBO_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TXBO_MASK;
        case CAN_ID_2 :
            return _C2TREC_TXBO_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_TXBP_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TXBP_MASK;
        case CAN_ID_2 :
            return _C2TREC_TXBP_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_RXBP_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_RXBP_MASK;
        case CAN_ID_2 :
            return _C2TREC_RXBP_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_TXWARN_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TXWARN_MASK;
        case CAN_ID_2 :
            return _C2TREC_TXWARN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_RXWARN_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_RXWARN_MASK;
        case CAN_ID_2 :
            return _C2TREC_RXWARN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_EWARN_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_EWARN_MASK;
        case CAN_ID_2 :
            return _C2TREC_EWARN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_ERR_COUNT_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TERRCNT_MASK;
        case CAN_ID_2 :
            return _C2TREC_TERRCNT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RECV_ERR_COUNT_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_RERRCNT_MASK;
        case CAN_ID_2 :
            return _C2TREC_RERRCNT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ALL_CHANNEL_EVENTS_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FSTAT_FIFOIP_MASK;
        case CAN_ID_2 :
            return _C2FSTAT_FIFOIP_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ALL_CHANNEL_OVERFLOW_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXOVF_RXOVF_MASK;
        case CAN_ID_2 :
            return _C2RXOVF_RXOVF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TIMESTAMP_SET_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TMR_CANTS_MASK;
        case CAN_ID_2 :
            return _C2TMR_CANTS_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TIMESTAMP_PRESCALER_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TMR_CANTSPRE_MASK;
        case CAN_ID_2 :
            return _C2TMR_CANTSPRE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK0_SID_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM0_SID_MASK;
        case CAN_ID_2 :
            return _C2RXM0_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK0_MIDE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM0_MIDE_MASK;
        case CAN_ID_2 :
            return _C2RXM0_MIDE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK0_EID_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM0_EID_MASK;
        case CAN_ID_2 :
            return _C2RXM0_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK1_SID_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM1_SID_MASK;
        case CAN_ID_2 :
            return _C2RXM1_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK1_MIDE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM1_MIDE_MASK;
        case CAN_ID_2 :
            return _C2RXM1_MIDE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK1_EID_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM1_EID_MASK;
        case CAN_ID_2 :
            return _C2RXM1_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK2_SID_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM2_SID_MASK;
        case CAN_ID_2 :
            return _C2RXM2_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK2_MIDE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM2_MIDE_MASK;
        case CAN_ID_2 :
            return _C2RXM2_MIDE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK2_EID_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM2_EID_MASK;
        case CAN_ID_2 :
            return _C2RXM2_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK3_SID_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM3_SID_MASK;
        case CAN_ID_2 :
            return _C2RXM3_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK3_MIDE_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM3_MIDE_MASK;
        case CAN_ID_2 :
            return _C2RXM3_MIDE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK3_EID_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM3_EID_MASK;
        case CAN_ID_2 :
            return _C2RXM3_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL0_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL0_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL0_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL0_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN0_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN0_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL1_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL1_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL1_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL1_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN1_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN1_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL2_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL2_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL2_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL2_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN2_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN2_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL3_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL3_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL3_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL3_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN3_MASK;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN3_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL4_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL4_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL4_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL4_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN4_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN4_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL5_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL5_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL5_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL5_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN5_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN5_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL6_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL6_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL6_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL6_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN6_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN6_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL7_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL7_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL7_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL7_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN7_MASK;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN7_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL8_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL8_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL8_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL8_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN8_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN8_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL9_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL9_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL9_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL9_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN9_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN9_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL10_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL10_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL10_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL10_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN10_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN10_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL11_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL11_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL11_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL11_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN11_MASK;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN11_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL12_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL12_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_MSEL12_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_MSEL12_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN12_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN12_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL13_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL13_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_MSEL13_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_MSEL13_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN13_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN13_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL14_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL14_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_MSEL14_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN14_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN14_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL15_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL15_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN15_MASK;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN15_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL16_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL16_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL16_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL16_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN16_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN16_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL17_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL17_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL17_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL17_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN17_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN17_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL18_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL18_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL18_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL18_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN18_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN18_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL19_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL19_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL19_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL19_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN19_MASK;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN19_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL20_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL20_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL20_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL20_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN20_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN20_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL21_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL21_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL21_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL21_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN21_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN21_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL22_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL22_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL22_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL22_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN22_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN22_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL23_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL23_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL23_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL23_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN23_MASK;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN23_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FSEL24_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_FSEL24_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL24_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL24_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN24_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN24_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FSEL25_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL25_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL25_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN25_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN25_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL26_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL26_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN26_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN26_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FSEL27_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_FSEL27_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL27_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL27_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN27_MASK;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN27_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL28_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL28_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL28_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL28_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN28_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN28_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL29_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL29_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL29_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL29_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN29_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN29_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL30_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL30_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL30_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL30_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN30_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN30_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL31_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL31_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL31_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL31_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN31_MASK;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN31_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF0_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF0_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF0_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF0_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF0_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF0_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF1_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF1_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF1_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF1_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF1_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF1_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF2_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF2_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF2_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF2_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF2_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF2_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF3_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF3_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF3_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF3_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF3_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF3_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF4_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF4_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF4_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF4_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF4_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF4_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF5_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF5_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF5_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF5_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF5_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF5_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF6_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF6_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF6_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF6_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF6_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF6_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF7_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF7_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF7_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF7_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF7_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF7_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF8_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF8_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF8_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF8_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF8_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF8_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF9_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF9_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF9_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF9_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF9_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF9_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF10_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF10_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF10_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF10_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF10_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF10_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF11_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF11_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF11_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF11_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF11_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF11_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF12_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF12_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF12_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF12_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF12_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF12_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF13_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF13_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF13_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF13_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF13_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF13_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF14_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF14_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF14_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF14_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF14_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF14_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF15_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF15_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF15_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF15_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF15_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF15_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF16_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF16_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF16_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF16_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF16_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF16_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF17_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF17_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF17_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF17_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF17_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF17_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF18_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF18_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF18_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF18_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF18_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF18_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF19_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF19_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF19_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF19_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF19_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF19_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF20_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF20_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF20_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF20_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF20_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF20_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF21_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF21_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF21_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF21_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF21_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF21_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF22_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF22_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF22_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF22_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF22_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF22_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF23_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF23_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF23_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF23_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF23_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF23_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF24_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF24_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF24_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF24_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF24_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF24_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF25_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF25_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF25_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF25_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF25_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF25_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF26_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF26_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF26_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF26_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF26_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF26_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF27_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF27_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF27_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF27_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF27_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF27_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF28_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF28_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF28_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF28_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF28_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF28_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF29_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF29_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF29_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF29_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF29_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF29_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF30_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF30_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF30_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF30_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF30_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF30_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF31_SID_MASK;
        case CAN_ID_2 :
            return _C2RXF31_SID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF31_EXID_MASK;
        case CAN_ID_2 :
            return _C2RXF31_EXID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF31_EID_MASK;
        case CAN_ID_2 :
            return _C2RXF31_EID_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MEMORY_BUFFER_ASSIGN_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON0_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON1_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON2_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON3_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON4_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON5_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON6_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON7_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON8_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON9_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON10_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON11_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON12_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON13_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON14_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON15_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON16_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON17_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON18_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON19_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON20_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON21_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON22_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON23_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON24_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON25_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON26_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON27_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON28_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON29_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON30_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXPRI_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXPRI_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_RTREN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_RTREN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXREQ_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXREQ_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXERR_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXERR_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXLARB_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXLARB_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXABAT_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXABAT_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXEN_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXEN_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_DONLY_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_DONLY_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_UINC_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_UINC_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_FRESET_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_FRESET_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_FSIZE_MASK;
        case CAN_ID_2 :
            return _C2FIFOCON31_FSIZE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXNFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXNFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXOVFLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXOVFLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXFULLIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXFULLIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXHALFIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXHALFIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXNEMPTYIE_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXNEMPTYIE_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXNFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXNFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXOVFLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXOVFLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXFULLIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXFULLIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXHALFIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXHALFIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXNEMPTYIF_MASK;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXNEMPTYIF_MASK;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL0_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL1_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL2_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL3_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL4_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL5_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL6_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL7_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL8_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL9_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL10_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL11_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL12_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL13_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL14_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL15_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL16_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL17_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL18_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL19_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL20_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL21_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL22_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL23_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL24_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL25_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL26_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL27_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL28_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL29_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL30_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL31_MASK(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)-1;
        case CAN_ID_2 :
            return (SFR_DATA)-1;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DEVICE_NET_CONFIG_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_DNCNT_POSITION;
        case CAN_ID_2 :
            return _C2CON_DNCNT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ACTIVE_STATUS_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_CANBUSY_POSITION;
        case CAN_ID_2 :
            return _C2CON_CANBUSY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_STOP_IN_IDLE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_SIDL_POSITION;
        case CAN_ID_2 :
            return _C2CON_SIDL_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ENABLE_CONTROL_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_ON_POSITION;
        case CAN_ID_2 :
            return _C2CON_ON_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TIMESTAMP_ENABLE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_CANCAP_POSITION;
        case CAN_ID_2 :
            return _C2CON_CANCAP_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_OPERATION_MODE_READ_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_OPMOD_POSITION;
        case CAN_ID_2 :
            return _C2CON_OPMOD_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_OPERATION_MODE_WRITE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_REQOP_POSITION;
        case CAN_ID_2 :
            return _C2CON_REQOP_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PENDING_TRANS_ABORT_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_ABAT_POSITION;
        case CAN_ID_2 :
            return _C2CON_ABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BAUD_RATE_PRESCALE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_BRP_POSITION;
        case CAN_ID_2 :
            return _C2CFG_BRP_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_SYNC_JUMP_WIDTH_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SJW_POSITION;
        case CAN_ID_2 :
            return _C2CFG_SJW_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PROPAGATION_TIME_SEG_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_PRSEG_POSITION;
        case CAN_ID_2 :
            return _C2CFG_PRSEG_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PHASE1_SEG_LENGTH_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SEG1PH_POSITION;
        case CAN_ID_2 :
            return _C2CFG_SEG1PH_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BUS_LINE_3TIMES_SAMPLING_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SAM_POSITION;
        case CAN_ID_2 :
            return _C2CFG_SAM_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PHASE2_SEG_LENGTH_FREELY_PGM_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SEG2PHTS_POSITION;
        case CAN_ID_2 :
            return _C2CFG_SEG2PHTS_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PHASE2_SEG_LENGTH_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SEG2PH_POSITION;
        case CAN_ID_2 :
            return _C2CFG_SEG2PH_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BUS_ACTIVITY_WAKEUP_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_WAKFIL_POSITION;
        case CAN_ID_2 :
            return _C2CFG_WAKFIL_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BUS_SPEED_SETUP_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_IVRIE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_IVRIE_POSITION;
        case CAN_ID_2 :
            return _C2INT_IVRIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_WAKIE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_WAKIE_POSITION;
        case CAN_ID_2 :
            return _C2INT_WAKIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_CERRIE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CERRIE_POSITION;
        case CAN_ID_2 :
            return _C2INT_CERRIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_SERRIE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_SERRIE_POSITION;
        case CAN_ID_2 :
            return _C2INT_SERRIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_RBOVIE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBOVIE_POSITION;
        case CAN_ID_2 :
            return _C2INT_RBOVIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_MODIE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_MODIE_POSITION;
        case CAN_ID_2 :
            return _C2INT_MODIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_CTMRIE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CTMRIE_POSITION;
        case CAN_ID_2 :
            return _C2INT_CTMRIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_RBIE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBIE_POSITION;
        case CAN_ID_2 :
            return _C2INT_RBIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_TBIE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_TBIE_POSITION;
        case CAN_ID_2 :
            return _C2INT_TBIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_IVRIF_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_IVRIF_POSITION;
        case CAN_ID_2 :
            return _C2INT_IVRIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_WAKIF_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_WAKIF_POSITION;
        case CAN_ID_2 :
            return _C2INT_WAKIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_CERRIF_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CERRIF_POSITION;
        case CAN_ID_2 :
            return _C2INT_CERRIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_SERRIF_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_SERRIF_POSITION;
        case CAN_ID_2 :
            return _C2INT_SERRIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_RBOVIF_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBOVIF_POSITION;
        case CAN_ID_2 :
            return _C2INT_RBOVIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_MODIF_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_MODIF_POSITION;
        case CAN_ID_2 :
            return _C2INT_MODIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_CTMRIF_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CTMRIF_POSITION;
        case CAN_ID_2 :
            return _C2INT_CTMRIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_RBIF_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBIF_POSITION;
        case CAN_ID_2 :
            return _C2INT_RBIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_TBIF_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_TBIF_POSITION;
        case CAN_ID_2 :
            return _C2INT_TBIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_LATEST_FILTER_MATCH_GET_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1VEC_FILHIT_POSITION;
        case CAN_ID_2 :
            return _C2VEC_FILHIT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PENDING_EVENTS_GET_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1VEC_ICODE_POSITION;
        case CAN_ID_2 :
            return _C2VEC_ICODE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_TXBO_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TXBO_POSITION;
        case CAN_ID_2 :
            return _C2TREC_TXBO_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_TXBP_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TXBP_POSITION;
        case CAN_ID_2 :
            return _C2TREC_TXBP_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_RXBP_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_RXBP_POSITION;
        case CAN_ID_2 :
            return _C2TREC_RXBP_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_TXWARN_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TXWARN_POSITION;
        case CAN_ID_2 :
            return _C2TREC_TXWARN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_RXWARN_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_RXWARN_POSITION;
        case CAN_ID_2 :
            return _C2TREC_RXWARN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_EWARN_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_EWARN_POSITION;
        case CAN_ID_2 :
            return _C2TREC_EWARN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_ERR_COUNT_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TERRCNT_POSITION;
        case CAN_ID_2 :
            return _C2TREC_TERRCNT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RECV_ERR_COUNT_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_RERRCNT_POSITION;
        case CAN_ID_2 :
            return _C2TREC_RERRCNT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ALL_CHANNEL_EVENTS_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FSTAT_FIFOIP_POSITION;
        case CAN_ID_2 :
            return _C2FSTAT_FIFOIP_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ALL_CHANNEL_OVERFLOW_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXOVF_RXOVF_POSITION;
        case CAN_ID_2 :
            return _C2RXOVF_RXOVF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TIMESTAMP_SET_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TMR_CANTS_POSITION;
        case CAN_ID_2 :
            return _C2TMR_CANTS_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TIMESTAMP_PRESCALER_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TMR_CANTSPRE_POSITION;
        case CAN_ID_2 :
            return _C2TMR_CANTSPRE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK0_SID_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM0_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXM0_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK0_MIDE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM0_MIDE_POSITION;
        case CAN_ID_2 :
            return _C2RXM0_MIDE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK0_EID_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM0_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXM0_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK1_SID_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM1_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXM1_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK1_MIDE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM1_MIDE_POSITION;
        case CAN_ID_2 :
            return _C2RXM1_MIDE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK1_EID_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM1_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXM1_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK2_SID_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM2_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXM2_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK2_MIDE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM2_MIDE_POSITION;
        case CAN_ID_2 :
            return _C2RXM2_MIDE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK2_EID_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM2_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXM2_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK3_SID_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM3_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXM3_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK3_MIDE_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM3_MIDE_POSITION;
        case CAN_ID_2 :
            return _C2RXM3_MIDE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK3_EID_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM3_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXM3_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL0_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL0_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL0_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL0_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN0_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN0_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL1_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL1_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL1_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL1_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN1_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN1_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL2_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL2_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL2_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL2_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN2_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN2_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL3_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL3_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL3_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL3_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN3_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN3_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL4_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL4_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL4_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL4_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN4_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN4_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL5_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL5_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL5_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL5_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN5_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN5_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL6_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL6_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL6_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL6_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN6_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN6_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL7_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL7_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL7_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL7_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN7_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN7_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL8_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL8_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL8_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL8_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN8_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN8_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL9_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL9_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL9_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL9_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN9_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN9_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL10_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL10_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL10_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL10_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN10_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN10_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL11_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL11_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL11_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL11_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN11_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN11_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL12_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL12_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_MSEL12_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_MSEL12_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN12_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN12_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL13_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL13_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_MSEL13_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_MSEL13_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN13_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN13_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL14_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL14_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_MSEL14_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN14_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN14_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL15_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL15_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN15_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN15_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL16_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL16_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL16_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL16_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN16_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN16_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL17_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL17_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL17_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL17_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN17_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN17_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL18_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL18_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL18_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL18_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN18_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN18_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL19_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL19_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL19_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL19_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN19_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN19_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL20_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL20_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL20_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL20_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN20_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN20_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL21_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL21_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL21_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL21_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN21_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN21_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL22_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL22_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL22_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL22_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN22_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN22_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL23_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL23_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL23_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL23_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN23_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN23_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FSEL24_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_FSEL24_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL24_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL24_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN24_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN24_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FSEL25_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL25_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL25_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN25_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN25_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL26_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL26_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN26_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN26_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FSEL27_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_FSEL27_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL27_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL27_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN27_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN27_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL28_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL28_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL28_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL28_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN28_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN28_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL29_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL29_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL29_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL29_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN29_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN29_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL30_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL30_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL30_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL30_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN30_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN30_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL31_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL31_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL31_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL31_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN31_POSITION;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN31_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF0_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF0_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF0_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF0_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF0_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF0_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF1_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF1_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF1_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF1_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF1_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF1_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF2_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF2_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF2_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF2_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF2_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF2_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF3_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF3_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF3_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF3_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF3_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF3_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF4_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF4_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF4_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF4_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF4_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF4_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF5_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF5_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF5_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF5_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF5_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF5_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF6_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF6_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF6_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF6_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF6_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF6_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF7_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF7_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF7_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF7_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF7_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF7_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF8_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF8_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF8_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF8_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF8_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF8_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF9_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF9_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF9_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF9_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF9_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF9_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF10_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF10_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF10_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF10_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF10_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF10_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF11_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF11_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF11_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF11_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF11_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF11_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF12_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF12_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF12_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF12_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF12_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF12_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF13_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF13_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF13_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF13_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF13_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF13_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF14_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF14_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF14_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF14_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF14_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF14_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF15_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF15_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF15_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF15_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF15_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF15_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF16_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF16_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF16_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF16_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF16_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF16_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF17_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF17_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF17_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF17_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF17_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF17_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF18_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF18_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF18_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF18_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF18_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF18_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF19_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF19_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF19_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF19_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF19_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF19_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF20_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF20_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF20_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF20_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF20_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF20_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF21_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF21_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF21_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF21_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF21_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF21_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF22_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF22_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF22_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF22_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF22_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF22_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF23_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF23_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF23_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF23_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF23_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF23_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF24_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF24_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF24_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF24_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF24_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF24_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF25_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF25_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF25_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF25_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF25_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF25_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF26_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF26_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF26_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF26_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF26_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF26_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF27_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF27_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF27_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF27_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF27_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF27_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF28_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF28_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF28_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF28_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF28_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF28_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF29_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF29_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF29_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF29_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF29_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF29_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF30_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF30_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF30_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF30_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF30_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF30_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF31_SID_POSITION;
        case CAN_ID_2 :
            return _C2RXF31_SID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF31_EXID_POSITION;
        case CAN_ID_2 :
            return _C2RXF31_EXID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF31_EID_POSITION;
        case CAN_ID_2 :
            return _C2RXF31_EID_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MEMORY_BUFFER_ASSIGN_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON0_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON1_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON2_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON3_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON4_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON5_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON6_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON7_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON8_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON9_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON10_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON11_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON12_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON13_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON14_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON15_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON16_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON17_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON18_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON19_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON20_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON21_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON22_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON23_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON24_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON25_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON26_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON27_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON28_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON29_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON30_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXPRI_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXPRI_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_RTREN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_RTREN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXREQ_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXREQ_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXERR_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXERR_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXLARB_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXLARB_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXABAT_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXABAT_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXEN_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXEN_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_DONLY_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_DONLY_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_UINC_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_UINC_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_FRESET_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_FRESET_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_FSIZE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOCON31_FSIZE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXNFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXNFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXOVFLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXOVFLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXFULLIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXFULLIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXHALFIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXHALFIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXNEMPTYIE_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXNEMPTYIE_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXNFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXNFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXOVFLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXOVFLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXFULLIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXFULLIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXHALFIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXHALFIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXNEMPTYIF_POSITION;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXNEMPTYIF_POSITION;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL0_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL1_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL2_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL3_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL4_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL5_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL6_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL7_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL8_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL9_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL10_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL11_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL12_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL13_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL14_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL15_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL16_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL17_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL18_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL19_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL20_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL21_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL22_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL23_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL24_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL25_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL26_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL27_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL28_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL29_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL30_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL31_POS(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)0;
        case CAN_ID_2 :
            return (SFR_DATA)0;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DEVICE_NET_CONFIG_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_DNCNT_LENGTH;
        case CAN_ID_2 :
            return _C2CON_DNCNT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ACTIVE_STATUS_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_CANBUSY_LENGTH;
        case CAN_ID_2 :
            return _C2CON_CANBUSY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_STOP_IN_IDLE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_SIDL_LENGTH;
        case CAN_ID_2 :
            return _C2CON_SIDL_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ENABLE_CONTROL_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_ON_LENGTH;
        case CAN_ID_2 :
            return _C2CON_ON_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TIMESTAMP_ENABLE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_CANCAP_LENGTH;
        case CAN_ID_2 :
            return _C2CON_CANCAP_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_OPERATION_MODE_READ_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_OPMOD_LENGTH;
        case CAN_ID_2 :
            return _C2CON_OPMOD_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_OPERATION_MODE_WRITE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_REQOP_LENGTH;
        case CAN_ID_2 :
            return _C2CON_REQOP_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PENDING_TRANS_ABORT_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CON_ABAT_LENGTH;
        case CAN_ID_2 :
            return _C2CON_ABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BAUD_RATE_PRESCALE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_BRP_LENGTH;
        case CAN_ID_2 :
            return _C2CFG_BRP_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_SYNC_JUMP_WIDTH_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SJW_LENGTH;
        case CAN_ID_2 :
            return _C2CFG_SJW_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PROPAGATION_TIME_SEG_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_PRSEG_LENGTH;
        case CAN_ID_2 :
            return _C2CFG_PRSEG_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PHASE1_SEG_LENGTH_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SEG1PH_LENGTH;
        case CAN_ID_2 :
            return _C2CFG_SEG1PH_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BUS_LINE_3TIMES_SAMPLING_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SAM_LENGTH;
        case CAN_ID_2 :
            return _C2CFG_SAM_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PHASE2_SEG_LENGTH_FREELY_PGM_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SEG2PHTS_LENGTH;
        case CAN_ID_2 :
            return _C2CFG_SEG2PHTS_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PHASE2_SEG_LENGTH_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_SEG2PH_LENGTH;
        case CAN_ID_2 :
            return _C2CFG_SEG2PH_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BUS_ACTIVITY_WAKEUP_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1CFG_WAKFIL_LENGTH;
        case CAN_ID_2 :
            return _C2CFG_WAKFIL_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_BUS_SPEED_SETUP_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_IVRIE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_IVRIE_LENGTH;
        case CAN_ID_2 :
            return _C2INT_IVRIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_WAKIE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_WAKIE_LENGTH;
        case CAN_ID_2 :
            return _C2INT_WAKIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_CERRIE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CERRIE_LENGTH;
        case CAN_ID_2 :
            return _C2INT_CERRIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_SERRIE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_SERRIE_LENGTH;
        case CAN_ID_2 :
            return _C2INT_SERRIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_RBOVIE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBOVIE_LENGTH;
        case CAN_ID_2 :
            return _C2INT_RBOVIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_MODIE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_MODIE_LENGTH;
        case CAN_ID_2 :
            return _C2INT_MODIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_CTMRIE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CTMRIE_LENGTH;
        case CAN_ID_2 :
            return _C2INT_CTMRIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_RBIE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBIE_LENGTH;
        case CAN_ID_2 :
            return _C2INT_RBIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_TBIE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_TBIE_LENGTH;
        case CAN_ID_2 :
            return _C2INT_TBIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_IVRIF_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_IVRIF_LENGTH;
        case CAN_ID_2 :
            return _C2INT_IVRIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_ENABLE_WAKIF_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_WAKIF_LENGTH;
        case CAN_ID_2 :
            return _C2INT_WAKIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_CERRIF_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CERRIF_LENGTH;
        case CAN_ID_2 :
            return _C2INT_CERRIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_SERRIF_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_SERRIF_LENGTH;
        case CAN_ID_2 :
            return _C2INT_SERRIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_RBOVIF_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBOVIF_LENGTH;
        case CAN_ID_2 :
            return _C2INT_RBOVIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_MODIF_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_MODIF_LENGTH;
        case CAN_ID_2 :
            return _C2INT_MODIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_CTMRIF_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_CTMRIF_LENGTH;
        case CAN_ID_2 :
            return _C2INT_CTMRIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_RBIF_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_RBIF_LENGTH;
        case CAN_ID_2 :
            return _C2INT_RBIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MODULE_EVENT_GET_TBIF_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1INT_TBIF_LENGTH;
        case CAN_ID_2 :
            return _C2INT_TBIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_LATEST_FILTER_MATCH_GET_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1VEC_FILHIT_LENGTH;
        case CAN_ID_2 :
            return _C2VEC_FILHIT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_PENDING_EVENTS_GET_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1VEC_ICODE_LENGTH;
        case CAN_ID_2 :
            return _C2VEC_ICODE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_TXBO_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TXBO_LENGTH;
        case CAN_ID_2 :
            return _C2TREC_TXBO_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_TXBP_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TXBP_LENGTH;
        case CAN_ID_2 :
            return _C2TREC_TXBP_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_RXBP_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_RXBP_LENGTH;
        case CAN_ID_2 :
            return _C2TREC_RXBP_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_TXWARN_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TXWARN_LENGTH;
        case CAN_ID_2 :
            return _C2TREC_TXWARN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_RXWARN_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_RXWARN_LENGTH;
        case CAN_ID_2 :
            return _C2TREC_RXWARN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ERR_STATE_EWARN_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_EWARN_LENGTH;
        case CAN_ID_2 :
            return _C2TREC_EWARN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_ERR_COUNT_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_TERRCNT_LENGTH;
        case CAN_ID_2 :
            return _C2TREC_TERRCNT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RECV_ERR_COUNT_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TREC_RERRCNT_LENGTH;
        case CAN_ID_2 :
            return _C2TREC_RERRCNT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ALL_CHANNEL_EVENTS_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FSTAT_FIFOIP_LENGTH;
        case CAN_ID_2 :
            return _C2FSTAT_FIFOIP_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_ALL_CHANNEL_OVERFLOW_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXOVF_RXOVF_LENGTH;
        case CAN_ID_2 :
            return _C2RXOVF_RXOVF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TIMESTAMP_SET_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TMR_CANTS_LENGTH;
        case CAN_ID_2 :
            return _C2TMR_CANTS_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TIMESTAMP_PRESCALER_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1TMR_CANTSPRE_LENGTH;
        case CAN_ID_2 :
            return _C2TMR_CANTSPRE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK0_SID_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM0_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXM0_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK0_MIDE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM0_MIDE_LENGTH;
        case CAN_ID_2 :
            return _C2RXM0_MIDE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK0_EID_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM0_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXM0_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK1_SID_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM1_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXM1_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK1_MIDE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM1_MIDE_LENGTH;
        case CAN_ID_2 :
            return _C2RXM1_MIDE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK1_EID_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM1_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXM1_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK2_SID_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM2_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXM2_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK2_MIDE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM2_MIDE_LENGTH;
        case CAN_ID_2 :
            return _C2RXM2_MIDE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK2_EID_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM2_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXM2_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK3_SID_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM3_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXM3_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK3_MIDE_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM3_MIDE_LENGTH;
        case CAN_ID_2 :
            return _C2RXM3_MIDE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_MASK3_EID_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXM3_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXM3_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL0_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL0_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL0_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL0_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN0_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN0_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL1_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL1_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL1_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL1_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN1_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN1_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL2_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL2_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL2_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL2_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN2_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN2_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FSEL3_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_FSEL3_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_MSEL3_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_MSEL3_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON0_FLTEN3_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON0_FLTEN3_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL4_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL4_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL4_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL4_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN4_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN4_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL5_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL5_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL5_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL5_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN5_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN5_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL6_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL6_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL6_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL6_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN6_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN6_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FSEL7_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_FSEL7_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_MSEL7_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_MSEL7_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON1_FLTEN7_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON1_FLTEN7_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL8_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL8_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL8_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL8_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN8_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN8_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL9_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL9_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL9_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL9_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN9_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN9_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL10_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL10_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL10_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL10_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN10_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN10_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FSEL11_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_FSEL11_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_MSEL11_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_MSEL11_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON2_FLTEN11_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON2_FLTEN11_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL12_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL12_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_MSEL12_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_MSEL12_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN12_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN12_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL13_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL13_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_MSEL13_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_MSEL13_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN13_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN13_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL14_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL14_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_MSEL14_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN14_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN14_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FSEL15_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_FSEL15_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON3_FLTEN15_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON3_FLTEN15_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL16_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL16_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL16_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL16_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN16_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN16_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL17_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL17_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL17_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL17_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN17_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN17_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL18_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL18_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL18_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL18_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN18_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN18_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FSEL19_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_FSEL19_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_MSEL19_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_MSEL19_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON4_FLTEN19_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON4_FLTEN19_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL20_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL20_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL20_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL20_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN20_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN20_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL21_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL21_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL21_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL21_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN21_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN21_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL22_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL22_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL22_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL22_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN22_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN22_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FSEL23_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_FSEL23_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_MSEL23_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_MSEL23_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON5_FLTEN23_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON5_FLTEN23_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FSEL24_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_FSEL24_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL24_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL24_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN24_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN24_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FSEL25_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL25_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL25_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN25_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN25_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL26_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL26_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN26_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN26_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FSEL27_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_FSEL27_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_MSEL27_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_MSEL27_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON6_FLTEN27_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON6_FLTEN27_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL28_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL28_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL28_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL28_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN28_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN28_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL29_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL29_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL29_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL29_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN29_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN29_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL30_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL30_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL30_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL30_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN30_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN30_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_FILTERSEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FSEL31_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_FSEL31_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_TO_CHANNEL_MASKSEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_MSEL31_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_MSEL31_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_ENABLE31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FLTCON7_FLTEN31_LENGTH;
        case CAN_ID_2 :
            return _C2FLTCON7_FLTEN31_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF0_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF0_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF0_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF0_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF0_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF0_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF1_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF1_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF1_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF1_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF1_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF1_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF2_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF2_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF2_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF2_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF2_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF2_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF3_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF3_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF3_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF3_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF3_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF3_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF4_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF4_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF4_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF4_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF4_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF4_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF5_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF5_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF5_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF5_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF5_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF5_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF6_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF6_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF6_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF6_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF6_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF6_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF7_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF7_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF7_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF7_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF7_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF7_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF8_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF8_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF8_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF8_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF8_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF8_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF9_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF9_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF9_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF9_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF9_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF9_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF10_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF10_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF10_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF10_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF10_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF10_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF11_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF11_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF11_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF11_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF11_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF11_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF12_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF12_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF12_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF12_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF12_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF12_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF13_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF13_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF13_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF13_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF13_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF13_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF14_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF14_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF14_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF14_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF14_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF14_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF15_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF15_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF15_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF15_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF15_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF15_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF16_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF16_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF16_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF16_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF16_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF16_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF17_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF17_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF17_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF17_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF17_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF17_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF18_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF18_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF18_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF18_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF18_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF18_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF19_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF19_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF19_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF19_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF19_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF19_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF20_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF20_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF20_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF20_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF20_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF20_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF21_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF21_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF21_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF21_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF21_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF21_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF22_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF22_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF22_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF22_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF22_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF22_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF23_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF23_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF23_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF23_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF23_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF23_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF24_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF24_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF24_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF24_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF24_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF24_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF25_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF25_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF25_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF25_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF25_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF25_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF26_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF26_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF26_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF26_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF26_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF26_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF27_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF27_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF27_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF27_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF27_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF27_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF28_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF28_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF28_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF28_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF28_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF28_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF29_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF29_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF29_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF29_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF29_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF29_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF30_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF30_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF30_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF30_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF30_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF30_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_SID31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF31_SID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF31_SID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EXID31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF31_EXID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF31_EXID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FILTER_CONFIGURE_EID31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1RXF31_EID_LENGTH;
        case CAN_ID_2 :
            return _C2RXF31_EID_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_MEMORY_BUFFER_ASSIGN_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON0_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON0_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON1_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON1_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON2_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON2_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON3_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON3_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON4_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON4_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON5_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON5_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON6_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON6_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON7_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON7_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON8_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON8_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON9_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON9_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON10_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON10_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON11_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON11_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON12_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON12_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON13_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON13_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON14_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON14_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON15_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON15_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON16_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON16_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON17_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON17_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON18_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON18_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON19_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON19_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON20_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON20_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON21_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON21_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON22_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON22_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON23_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON23_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON24_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON24_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON25_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON25_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON26_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON26_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON27_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON27_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON28_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON28_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON29_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON29_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON30_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON30_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_PRIORITY_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXPRI_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXPRI_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANSMIT_RTREN_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_RTREN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_RTREN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_FLUSH_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXREQ_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXREQ_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXERR_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXERR_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXERR_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_STATUS_TXLARB_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXLARB_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXLARB_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TRANS_ABORT_STATUS_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXABAT_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXABAT_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_DIRECTION_SET_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_TXEN_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_TXEN_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FOR_RECV_SET_DONLY_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_DONLY_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_DONLY_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_UPDATE_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_UINC_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_UINC_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_RESET_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_FRESET_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_FRESET_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_FSIZE_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOCON31_FSIZE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOCON31_FSIZE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT0_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT0_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT1_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT1_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT2_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT2_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT3_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT3_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT4_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT4_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT5_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT5_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT6_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT6_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT7_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT7_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT8_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT8_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT9_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT9_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT10_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT10_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT11_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT11_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT12_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT12_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT13_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT13_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT14_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT14_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT15_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT15_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT16_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT16_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT17_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT17_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT18_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT18_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT19_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT19_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT20_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT20_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT21_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT21_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT22_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT22_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT23_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT23_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT24_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT24_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT25_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT25_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT26_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT26_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT27_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT27_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT28_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT28_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT29_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT29_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT30_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT30_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXNFULL_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXNFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXNFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXHALF_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_TXEMPTY_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXOVFL_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXOVFLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXOVFLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXFULL_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXFULLIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXFULLIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXHALF_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXHALFIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXHALFIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_ENABLE_RXNEMPTY_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXNEMPTYIE_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXNEMPTYIE_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXNFULL_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXNFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXNFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXHALF_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_TXEMPTY_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_TXEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_TXEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXOVFL_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXOVFLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXOVFLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXFULL_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXFULLIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXFULLIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXHALF_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXHALFIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXHALFIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_EVENT_FLAG_RXNEMPTY_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return _C1FIFOINT31_RXNEMPTYIF_LENGTH;
        case CAN_ID_2 :
            return _C2FIFOINT31_RXNEMPTYIF_LENGTH;
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL0_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL1_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL2_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL3_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL4_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL5_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL6_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL7_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL8_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL9_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL10_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL11_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL12_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL13_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL14_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL15_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL16_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL17_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL18_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL19_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL20_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL21_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL22_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL23_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL24_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL25_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL26_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL27_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL28_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL29_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL30_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

PLIB_INLINE SFR_DATA _CAN_TX_RX_USER_ADDRESS_CHANNEL31_LEN(CAN_MODULE_ID i)
{
    switch (i) {
        case CAN_ID_1 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_ID_2 :
            return (SFR_DATA)sizeof(SFR_DATA);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (SFR_DATA)-1;
    }
}

/* Section 2 - Feature variant inclusion */

#define PLIB_TEMPLATE PLIB_INLINE
#include "../templates/can_DeviceNet_Default.h"
#include "../templates/can_ActiveStatus_Default.h"
#include "../templates/can_StopInIdle_Default.h"
#include "../templates/can_EnableControl_Default.h"
#include "../templates/can_TimeStampEnable_Default.h"
#include "../templates/can_TimeStampValue_Default.h"
#include "../templates/can_BusActivityWakeup_Default.h"
#include "../templates/can_MemoryBufferAssign_Default.h"
#include "../templates/can_OperationModeRead_Default.h"
#include "../templates/can_OperationModeSet_Default.h"
#include "../templates/can_TimeStampPrescaler_Default.h"
#include "../templates/can_PhaseSegment2Length_Default.h"
#include "../templates/can_PhaseSegment1Length_Default.h"
#include "../templates/can_PhaseSegment2LengthFreelyProgrammable_Default.h"
#include "../templates/can_BusLine3TimesSampling_Default.h"
#include "../templates/can_PropagationTimeSegment_Default.h"
#include "../templates/can_SyncJumpWidth_Default.h"
#include "../templates/can_BaudRatePrescale_Default.h"
#include "../templates/can_BusSpeed_Default.h"
#include "../templates/can_ChannelReset_pic32.h"
#include "../templates/can_ChannelUpdate_pic32.h"
#include "../templates/can_ModuleEventEnable_Default.h"
#include "../templates/can_ModuleEvents_Default.h"
#include "../templates/can_ChannelEventEnable_pic32.h"
#include "../templates/can_PendingEventsGet_Default.h"
#include "../templates/can_AllChannelEvents_Default.h"
#include "../templates/can_AllChannelOverflow_Default.h"
#include "../templates/can_ChannelEventGet_Default.h"
#include "../templates/can_ChannelForTransmitSet_pic32.h"
#include "../templates/can_PendingTransmissionsAbort_Default.h"
#include "../templates/can_TransmitChannelFlush_pic32.h"
#include "../templates/can_TransmitChannelStatus_pic32.h"
#include "../templates/can_TransmitBufferGet_pic32.h"
#include "../templates/can_TransmissionAbortStatus_pic32.h"
#include "../templates/can_ReceivedMessageGet_pic32.h"
#include "../templates/can_ChannelForReceiveSet_pic32.h"
#include "../templates/can_FilterMaskConfigure_pic32.h"
#include "../templates/can_FilterConfigure_pic32.h"
#include "../templates/can_FilterEnable_pic32.h"
#include "../templates/can_LatestFilterMatchGet_pic32.h"
#include "../templates/can_FilterToChannelLink_pic32.h"
#include "../templates/can_ReceiveErrorCount_Default.h"
#include "../templates/can_TransmitErrorCountGet_Default.h"
#include "../templates/can_ErrorStateGet_Default.h"
#include "../templates/can_ModuleInformation_Default.h"

/* Section 3 - PLIB dispatch function definitions */

PLIB_INLINE_API void PLIB_CAN_DeviceNetConfigure(CAN_MODULE_ID index, CAN_DNET_FILTER_SIZE dncnt)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_DeviceNetConfigure_Default(index, dncnt);
            break;
        case CAN_ID_2 :
            CAN_DeviceNetConfigure_Default(index, dncnt);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsDeviceNet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsDeviceNet_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsDeviceNet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_IsActive(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_IsActive_Default(index);
        case CAN_ID_2 :
            return CAN_IsActive_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsActiveStatus(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsActiveStatus_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsActiveStatus_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_StopInIdleEnable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_StopInIdleEnable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_StopInIdleEnable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API void PLIB_CAN_StopInIdleDisable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_StopInIdleDisable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_StopInIdleDisable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsStopInIdle(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsStopInIdle_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsStopInIdle_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_Enable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_Enable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_Enable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API void PLIB_CAN_Disable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_Disable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_Disable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsEnableControl(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsEnableControl_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsEnableControl_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_TimeStampEnable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_TimeStampEnable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_TimeStampEnable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API void PLIB_CAN_TimeStampDisable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_TimeStampDisable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_TimeStampDisable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsTimeStampEnable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsTimeStampEnable_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsTimeStampEnable_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_TimeStampValueSet(CAN_MODULE_ID index, unsigned value)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_TimeStampValueSet_Default(index, value);
            break;
        case CAN_ID_2 :
            CAN_TimeStampValueSet_Default(index, value);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API unsigned PLIB_CAN_TimeStampValueGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_TimeStampValueGet_Default(index);
        case CAN_ID_2 :
            return CAN_TimeStampValueGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (unsigned)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsTimeStampValue(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsTimeStampValue_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsTimeStampValue_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_BusActivityWakeupEnable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_BusActivityWakeupEnable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_BusActivityWakeupEnable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API void PLIB_CAN_BusActivityWakeupDisable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_BusActivityWakeupDisable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_BusActivityWakeupDisable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsBusActivityWakeup(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsBusActivityWakeup_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsBusActivityWakeup_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_MemoryBufferAssign(CAN_MODULE_ID index, void* buffer)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_MemoryBufferAssign_Default(index, buffer);
            break;
        case CAN_ID_2 :
            CAN_MemoryBufferAssign_Default(index, buffer);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsMemoryBufferAssign(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsMemoryBufferAssign_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsMemoryBufferAssign_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_OPERATION_MODES PLIB_CAN_OperationModeGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_OperationModeGet_Default(index);
        case CAN_ID_2 :
            return CAN_OperationModeGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_OPERATION_MODES)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsOperationModeRead(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsOperationModeRead_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsOperationModeRead_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_OperationModeSelect(CAN_MODULE_ID index, CAN_OPERATION_MODES opMode)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_OperationModeSelect_Default(index, opMode);
            break;
        case CAN_ID_2 :
            CAN_OperationModeSelect_Default(index, opMode);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsOperationModeWrite(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsOperationModeWrite_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsOperationModeWrite_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_TimeStampPrescalerSet(CAN_MODULE_ID index, unsigned preScaler)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_TimeStampPrescalerSet_Default(index, preScaler);
            break;
        case CAN_ID_2 :
            CAN_TimeStampPrescalerSet_Default(index, preScaler);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsTimeStampPrescaler(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsTimeStampPrescaler_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsTimeStampPrescaler_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_PhaseSegment2LengthSet(CAN_MODULE_ID index, CAN_TIME_SEGMENT_LENGTH length)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_PhaseSegment2LengthSet_Default(index, length);
            break;
        case CAN_ID_2 :
            CAN_PhaseSegment2LengthSet_Default(index, length);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsPhaseSegment2Length(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsPhaseSegment2Length_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsPhaseSegment2Length_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_PhaseSegment1LengthSet(CAN_MODULE_ID index, CAN_TIME_SEGMENT_LENGTH length)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_PhaseSegment1LengthSet_Default(index, length);
            break;
        case CAN_ID_2 :
            CAN_PhaseSegment1LengthSet_Default(index, length);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsPhaseSegment1Length(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsPhaseSegment1Length_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsPhaseSegment1Length_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_PhaseSegment2LengthFreelyProgrammableEnable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_PhaseSegment2LengthFreelyProgrammableEnable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_PhaseSegment2LengthFreelyProgrammableEnable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API void PLIB_CAN_PhaseSegment2LengthFreelyProgrammableDisable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_PhaseSegment2LengthFreelyProgrammableDisable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_PhaseSegment2LengthFreelyProgrammableDisable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsPhaseSegment2LengthFreelyProgrammable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsPhaseSegment2LengthFreelyProgrammable_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsPhaseSegment2LengthFreelyProgrammable_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_BusLine3TimesSamplingEnable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_BusLine3TimesSamplingEnable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_BusLine3TimesSamplingEnable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API void PLIB_CAN_BusLine3TimesSamplingDisable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_BusLine3TimesSamplingDisable_Default(index);
            break;
        case CAN_ID_2 :
            CAN_BusLine3TimesSamplingDisable_Default(index);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsBusLine3TimesSampling(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsBusLine3TimesSampling_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsBusLine3TimesSampling_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_PropagationTimeSegmentSet(CAN_MODULE_ID index, CAN_TIME_SEGMENT_LENGTH length)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_PropagationTimeSegmentSet_Default(index, length);
            break;
        case CAN_ID_2 :
            CAN_PropagationTimeSegmentSet_Default(index, length);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsPropagationTimeSegment(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsPropagationTimeSegment_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsPropagationTimeSegment_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_SyncJumpWidthSet(CAN_MODULE_ID index, CAN_TIME_SEGMENT_LENGTH length)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_SyncJumpWidthSet_Default(index, length);
            break;
        case CAN_ID_2 :
            CAN_SyncJumpWidthSet_Default(index, length);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsSyncJumpWidthSet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsSyncJumpWidthSet_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsSyncJumpWidthSet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_BaudRatePrescaleSet(CAN_MODULE_ID index, CAN_BAUD_RATE_PRESCALE prescale)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_BaudRatePrescaleSet_Default(index, prescale);
            break;
        case CAN_ID_2 :
            CAN_BaudRatePrescaleSet_Default(index, prescale);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsBaudRatePrescale(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsBaudRatePrescale_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsBaudRatePrescale_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_PrecalculatedBitRateSetup(CAN_MODULE_ID index, uint8_t prescale, uint8_t syncjumpWidth, uint8_t propagation, uint8_t segment1, uint8_t segment2)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_PrecalculatedBitRateSetup_Default(index, prescale, syncjumpWidth, propagation, segment1, segment2);
        case CAN_ID_2 :
            return CAN_PrecalculatedBitRateSetup_Default(index, prescale, syncjumpWidth, propagation, segment1, segment2);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsPrecalculatedBitRateSetup(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsPrecalculatedBitRateSetup_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsPrecalculatedBitRateSetup_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_BitSamplePhaseSet(CAN_MODULE_ID index, uint8_t syncJumpWidth, uint8_t propagation, uint8_t segment1, uint8_t segment2)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_BitSamplePhaseSet_Default(index, syncJumpWidth, propagation, segment1, segment2);
        case CAN_ID_2 :
            return CAN_BitSamplePhaseSet_Default(index, syncJumpWidth, propagation, segment1, segment2);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsBitSamplePhaseSet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsBitSamplePhaseSet_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsBitSamplePhaseSet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_BaudRatePrescaleSetup(CAN_MODULE_ID index, uint16_t prescale)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_BaudRatePrescaleSetup_Default(index, prescale);
        case CAN_ID_2 :
            return CAN_BaudRatePrescaleSetup_Default(index, prescale);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsBaudRatePrescaleSetup(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsBaudRatePrescaleSetup_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsBaudRatePrescaleSetup_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API uint32_t PLIB_CAN_BaudRateGet(CAN_MODULE_ID index, uint32_t sysclock)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_BaudRateGet_Default(index, sysclock);
        case CAN_ID_2 :
            return CAN_BaudRateGet_Default(index, sysclock);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (uint32_t)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsBaudRateGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsBaudRateGet_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsBaudRateGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_ChannelReset(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ChannelReset_pic32(index, channel);
            break;
        case CAN_ID_2 :
            CAN_ChannelReset_pic32(index, channel);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ChannelResetIsComplete(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ChannelResetIsComplete_pic32(index, channel);
        case CAN_ID_2 :
            return CAN_ChannelResetIsComplete_pic32(index, channel);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsChannelReset(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsChannelReset_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsChannelReset_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_ChannelUpdate(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ChannelUpdate_pic32(index, channel);
            break;
        case CAN_ID_2 :
            CAN_ChannelUpdate_pic32(index, channel);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsChannelUpdate(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsChannelUpdate_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsChannelUpdate_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_ModuleEventEnable(CAN_MODULE_ID index, CAN_MODULE_EVENT flags)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ModuleEventEnable_Default(index, flags);
            break;
        case CAN_ID_2 :
            CAN_ModuleEventEnable_Default(index, flags);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API void PLIB_CAN_ModuleEventDisable(CAN_MODULE_ID index, CAN_MODULE_EVENT flags)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ModuleEventDisable_Default(index, flags);
            break;
        case CAN_ID_2 :
            CAN_ModuleEventDisable_Default(index, flags);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsModuleEventEnable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsModuleEventEnable_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsModuleEventEnable_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_ModuleEventClear(CAN_MODULE_ID index, CAN_MODULE_EVENT flags)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ModuleEventClear_Default(index, flags);
            break;
        case CAN_ID_2 :
            CAN_ModuleEventClear_Default(index, flags);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API CAN_MODULE_EVENT PLIB_CAN_ModuleEventGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ModuleEventGet_Default(index);
        case CAN_ID_2 :
            return CAN_ModuleEventGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_MODULE_EVENT)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsModuleEventClear(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsModuleEventClear_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsModuleEventClear_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_ChannelEventEnable(CAN_MODULE_ID index, CAN_CHANNEL channel, CAN_CHANNEL_EVENT flags)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ChannelEventEnable_pic32(index, channel, flags);
            break;
        case CAN_ID_2 :
            CAN_ChannelEventEnable_pic32(index, channel, flags);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API void PLIB_CAN_ChannelEventDisable(CAN_MODULE_ID index, CAN_CHANNEL channel, CAN_CHANNEL_EVENT flags)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ChannelEventDisable_pic32(index, channel, flags);
            break;
        case CAN_ID_2 :
            CAN_ChannelEventDisable_pic32(index, channel, flags);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsChannelEventEnable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsChannelEventEnable_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsChannelEventEnable_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_EVENT_CODE PLIB_CAN_PendingEventsGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_PendingEventsGet_Default(index);
        case CAN_ID_2 :
            return CAN_PendingEventsGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_EVENT_CODE)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsPendingEventsGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsPendingEventsGet_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsPendingEventsGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_CHANNEL_MASK PLIB_CAN_AllChannelEventsGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_AllChannelEventsGet_Default(index);
        case CAN_ID_2 :
            return CAN_AllChannelEventsGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_CHANNEL_MASK)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsAllChannelEvents(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsAllChannelEvents_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsAllChannelEvents_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_CHANNEL_MASK PLIB_CAN_AllChannelOverflowStatusGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_AllChannelOverflowStatusGet_Default(index);
        case CAN_ID_2 :
            return CAN_AllChannelOverflowStatusGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_CHANNEL_MASK)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsAllChannelOverflow(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsAllChannelOverflow_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsAllChannelOverflow_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_CHANNEL_EVENT PLIB_CAN_ChannelEventGet(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ChannelEventGet_Default(index, channel);
        case CAN_ID_2 :
            return CAN_ChannelEventGet_Default(index, channel);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_CHANNEL_EVENT)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_ChannelEventClear(CAN_MODULE_ID index, CAN_CHANNEL channel, CAN_CHANNEL_EVENT events)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ChannelEventClear_Default(index, channel, events);
            break;
        case CAN_ID_2 :
            CAN_ChannelEventClear_Default(index, channel, events);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsChannelEvent(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsChannelEvent_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsChannelEvent_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_ChannelForTransmitSet(CAN_MODULE_ID index, CAN_CHANNEL channel, uint8_t channelSize, CAN_TX_RTR rtren, CAN_TXCHANNEL_PRIORITY priority)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ChannelForTransmitSet_pic32(index, channel, channelSize, rtren, priority);
            break;
        case CAN_ID_2 :
            CAN_ChannelForTransmitSet_pic32(index, channel, channelSize, rtren, priority);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsChannelForTransmitSet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsChannelForTransmitSet_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsChannelForTransmitSet_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_PendingTransmissionsAbort(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_PendingTransmissionsAbort_Default(index, channel);
            break;
        case CAN_ID_2 :
            CAN_PendingTransmissionsAbort_Default(index, channel);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsPendingTransmissionsAbort(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsPendingTransmissionsAbort_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsPendingTransmissionsAbort_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_TransmitChannelFlush(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_TransmitChannelFlush_pic32(index, channel);
            break;
        case CAN_ID_2 :
            CAN_TransmitChannelFlush_pic32(index, channel);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsTransmitChannelFlush(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsTransmitChannelFlush_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsTransmitChannelFlush_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_TX_CHANNEL_STATUS PLIB_CAN_TransmitChannelStatusGet(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_TransmitChannelStatusGet_pic32(index, channel);
        case CAN_ID_2 :
            return CAN_TransmitChannelStatusGet_pic32(index, channel);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_TX_CHANNEL_STATUS)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsTransmitChannelStatus(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsTransmitChannelStatus_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsTransmitChannelStatus_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_TX_MSG_BUFFER* PLIB_CAN_TransmitBufferGet(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_TransmitBufferGet_pic32(index, channel);
        case CAN_ID_2 :
            return CAN_TransmitBufferGet_pic32(index, channel);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_TX_MSG_BUFFER*)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsTransmitBufferGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsTransmitBufferGet_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsTransmitBufferGet_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_TransmissionIsAborted(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_TransmissionIsAborted_pic32(index, channel);
        case CAN_ID_2 :
            return CAN_TransmissionIsAborted_pic32(index, channel);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsTransmissionIsAborted(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsTransmissionIsAborted_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsTransmissionIsAborted_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_RX_MSG_BUFFER* PLIB_CAN_ReceivedMessageGet(CAN_MODULE_ID index, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ReceivedMessageGet_pic32(index, channel);
        case CAN_ID_2 :
            return CAN_ReceivedMessageGet_pic32(index, channel);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_RX_MSG_BUFFER*)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsReceivedMessageGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsReceivedMessageGet_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsReceivedMessageGet_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_ChannelForReceiveSet(CAN_MODULE_ID index, CAN_CHANNEL channel, uint32_t channelSize, CAN_RX_DATA_MODE dataOnly)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_ChannelForReceiveSet_pic32(index, channel, channelSize, dataOnly);
            break;
        case CAN_ID_2 :
            CAN_ChannelForReceiveSet_pic32(index, channel, channelSize, dataOnly);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsChannelForReceiveSet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsChannelForReceiveSet_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsChannelForReceiveSet_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_FilterMaskConfigure(CAN_MODULE_ID index, CAN_FILTER_MASK mask, uint32_t maskBits, CAN_ID_TYPE idType, CAN_FILTER_MASK_TYPE mide)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_FilterMaskConfigure_pic32(index, mask, maskBits, idType, mide);
            break;
        case CAN_ID_2 :
            CAN_FilterMaskConfigure_pic32(index, mask, maskBits, idType, mide);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsFilterMaskConfigure(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsFilterMaskConfigure_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsFilterMaskConfigure_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_FilterConfigure(CAN_MODULE_ID index, CAN_FILTER filter, uint32_t id, CAN_ID_TYPE filterType)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_FilterConfigure_pic32(index, filter, id, filterType);
            break;
        case CAN_ID_2 :
            CAN_FilterConfigure_pic32(index, filter, id, filterType);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsFilterConfigure(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsFilterConfigure_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsFilterConfigure_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_FilterEnable(CAN_MODULE_ID index, CAN_FILTER filter)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_FilterEnable_pic32(index, filter);
            break;
        case CAN_ID_2 :
            CAN_FilterEnable_pic32(index, filter);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API void PLIB_CAN_FilterDisable(CAN_MODULE_ID index, CAN_FILTER filter)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_FilterDisable_pic32(index, filter);
            break;
        case CAN_ID_2 :
            CAN_FilterDisable_pic32(index, filter);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_FilterIsDisabled(CAN_MODULE_ID index, CAN_FILTER filter)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_FilterIsDisabled_pic32(index, filter);
        case CAN_ID_2 :
            return CAN_FilterIsDisabled_pic32(index, filter);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsFilterEnable(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsFilterEnable_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsFilterEnable_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_FILTER PLIB_CAN_LatestFilterMatchGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_LatestFilterMatchGet_pic32(index);
        case CAN_ID_2 :
            return CAN_LatestFilterMatchGet_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_FILTER)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsLatestFilterMatchGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsLatestFilterMatchGet_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsLatestFilterMatchGet_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API void PLIB_CAN_FilterToChannelLink(CAN_MODULE_ID index, CAN_FILTER filter, CAN_FILTER_MASK mask, CAN_CHANNEL channel)
{
    switch (index) {
        case CAN_ID_1 :
            CAN_FilterToChannelLink_pic32(index, filter, mask, channel);
            break;
        case CAN_ID_2 :
            CAN_FilterToChannelLink_pic32(index, filter, mask, channel);
            break;
        case CAN_NUMBER_OF_MODULES :
        default :
            break;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsFilterToChannelLink(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsFilterToChannelLink_pic32(index);
        case CAN_ID_2 :
            return CAN_ExistsFilterToChannelLink_pic32(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API int PLIB_CAN_ReceiveErrorCountGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ReceiveErrorCountGet_Default(index);
        case CAN_ID_2 :
            return CAN_ReceiveErrorCountGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (int)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsReceiveErrorCount(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsReceiveErrorCount_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsReceiveErrorCount_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API int PLIB_CAN_TransmitErrorCountGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_TransmitErrorCountGet_Default(index);
        case CAN_ID_2 :
            return CAN_TransmitErrorCountGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (int)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsTransmitErrorCountGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsTransmitErrorCountGet_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsTransmitErrorCountGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API CAN_ERROR_STATE PLIB_CAN_ErrorStateGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ErrorStateGet_Default(index);
        case CAN_ID_2 :
            return CAN_ErrorStateGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (CAN_ERROR_STATE)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsErrorState(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsErrorState_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsErrorState_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

PLIB_INLINE_API char PLIB_CAN_TotalChannelsGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_TotalChannelsGet_Default(index);
        case CAN_ID_2 :
            return CAN_TotalChannelsGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (char)0;
    }
}

PLIB_INLINE_API char PLIB_CAN_TotalFiltersGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_TotalFiltersGet_Default(index);
        case CAN_ID_2 :
            return CAN_TotalFiltersGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (char)0;
    }
}

PLIB_INLINE_API char PLIB_CAN_TotalMasksGet(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_TotalMasksGet_Default(index);
        case CAN_ID_2 :
            return CAN_TotalMasksGet_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (char)0;
    }
}

PLIB_INLINE_API bool PLIB_CAN_ExistsModuleInfo(CAN_MODULE_ID index)
{
    switch (index) {
        case CAN_ID_1 :
            return CAN_ExistsModuleInfo_Default(index);
        case CAN_ID_2 :
            return CAN_ExistsModuleInfo_Default(index);
        case CAN_NUMBER_OF_MODULES :
        default :
            return (bool)0;
    }
}

#endif
